#!/usr/bin/env ruby
 
require 'gtk2'
require 'get_client_list'
require 'set_status'
require 'web_control_cmd'
require'xvnc_cmd'
require 'lock_control_cmd'
require '~/.laulc/conf/global'
  include Gtk
require 'gettext'
include GetText
 bindtextdomain("client_table", :path => '/usr/local/bin/km/liveusbcontrol/locale') 

 class ClientTable < Window
	@eventbox
	@tab
	@rot
	@orange
	@gruen
	@blau
	@filename
	@ipaddress
	@button1
	@hbox
	@hbox1
	@vbox
	@reihen
	@delete
	@sort
	
	def initialize
         
        super

	#system("#{$gb_working_dir}/teacher_entry1.rb")
	system("#{$gb_working_dir}/teacher_pincode.rb")
	load '~/.laulc/conf/global.rb'
        @button1 = Array.new
        @rot = Gdk::Color.new( 65535, 0, 0 )
        @orange = Gdk::Color.new( 65535, 45525, 0 )
        @gruen = Gdk::Color.new( 0, 65535, 0 )
        @blau = Gdk::Color.new( 0, 0, 65535 )
	@gray = Gdk::Color.new( 40000, 40000, 40000 )
        @purpur = Gdk::Color.new( 65535, 40000, 40000 )
	@yellow = Gdk::Color.new( 65535, 65535, 00000 )

        self.set_border_width( 10 )
        self.set_window_position( Position::CENTER )
	self.set_icon("#{$gb_working_dir}/icons/la-ts.png")
	self.set_resizable( false )
        clientlist=GetClientList.new("#{$gb_dir}/#{$gb_clientlist}")
	name=clientlist.get_clientname
	group=clientlist.get_group
	exam=clientlist.get_exam
	status=clientlist.get_status
	control=clientlist.get_control
	laulc=clientlist.get_laulc
	@filename=clientlist.get_filename
	listlength=name.length
	@reihen=$gb_reihen.to_i
	#puts listlength  / @reihen

        @tab = Table.new( listlength /@reihen +1, @reihen, true )
        @tab.set_column_spacings( 3 )
        @tab.set_row_spacings( 3 )

	#@eventbox=EventBox.new
	#@eventbox.add(@tab)
	#self.add( @eventbox )
        @vbox = VBox.new(false, 3)
        @hbox = HBox.new(false, 3)
        #open = Button.new("OPEN")
        #open.modify_bg( STATE_NORMAL, @gruen )
        #open.modify_bg( STATE_ACTIVE, @gruen )
        #open.modify_bg( STATE_PRELIGHT, @gruen )
        #close = Button.new("CLOSE")
        #close.modify_bg( StateType::NORMAL, @rot )
        #close.modify_bg( STATE_ACTIVE, @rot )
        #close.modify_bg( STATE_PRELIGHT, @rot )
        #@hbox.add(open)
        #@hbox.add(close)
        @vbox.pack_start(@tab)
        #@vbox.add(@hbox)
        
	@hbox1=HBox.new(false,5)
	#number of rows
	#@number=ComboBox.new
	#@number.append_text('1')
	#@number.append_text('2')
	#@number.append_text('3')
	#@number.append_text('4')
	#@number.append_text('5')
	#@number.append_text('6')
	#@number.append_text('7')
	#@number.set_active(3)
	#@hbox1.add(@number)

	#sort by name
	@sort=Button.new(_("Sort by Name"))
	@sort.signal_connect( "clicked" ) do
             on_sort_clicked				
	end

	
	#@hbox1.add(@sort)	




	#buttons for delete clientlist
	@delete=Button.new(_("Delete All Student-Clients"))
	@delete.signal_connect( "clicked" ) do
             on_delete_clicked				
	end
	#@hbox1.add(@delete)

	#@vbox.add(@hbox1)


        self.add(@vbox)
        self.set_title( _("LA-Student-Clients") )
        self.show_all
        ipstatusget
        firefoxstatus
	lockstatus
	laulcstatus
	examstatus
	#system("(#{$gb_dir}/actual.sh #{$gb_dir} #{$gb_clientlist})&")
	actual
        starte_animation
        
    end

	def on_sort_clicked
		#puts "sort"
           clientlist=GetClientList.new("#{$gb_dir}/#{$gb_clientlist}")
	clientlist.sort_by_name("#{$gb_dir}/#{$gb_clientlist}")
	
	end

	def on_delete_clicked
		msg = _("All Student-Clients will be deleted from the table")
        	#MessageDialog
        	dialog = MessageDialog.new( nil, 0, 1, 5, msg )
        	dialog.run do
            	|response|
            	if response == -5
			system("rm #{$gb_dir}/#{$gb_clientlist};touch #{$gb_dir}/#{$gb_clientlist}")
			system("sudo killall vncviewer")
                	dialog.destroy
               		 return false
                                                                     
            	elsif response == -6
                	dialog.destroy
               
                	return true
            	end
        	end	
	
	end
	
    def firefoxstatus
    	Thread.start do
    		loop do
		#puts "FIREEEE"
		#sleep(5)
    		firefox=SetStatus.new("#{$gb_dir}/#{$gb_clientlist}")
    		firefox.set_firefoxstatus
    		end
    	end
    end
    
    def ipstatusget
    	Thread.start do
    		loop do
    		status=SetStatus.new("#{$gb_dir}/#{$gb_clientlist}")
    		status.set_ipstatus
    		end
    	end
    end
    

	def lockstatus
    	Thread.start do
    		loop do
		#puts "LOCKCKCK"
    		status=SetStatus.new("#{$gb_dir}/#{$gb_clientlist}")
    		status.set_lockstatus
    		end
    	end
    end

	def examstatus
    	Thread.start do
    		loop do
		#puts "EXAM"
    		status=SetStatus.new("#{$gb_dir}/#{$gb_clientlist}")
    		status.set_examstatus
    		end
    	end
    end

	def laulcstatus
    	Thread.start do
    		loop do
		#puts "LOCKCKCK"
    		status=SetStatus.new("#{$gb_dir}/#{$gb_clientlist}")
    		status.set_laulcstatus
    		end
    	end
    end

   	def actual
	
	Thread.start do
		loop do
		#puts "ACTUAL"
		status=SetStatus.new("#{$gb_dir}/#{$gb_clientlist}")
    		status.set_actual
		end
	end
	end

#Animation
    def starte_animation
        k = 0
        Thread.start do
            loop do #Endlosschleife
            	#puts "sadf"
                @vbox.remove(@tab)
		@vbox.remove(@hbox1)
		clientlist=GetClientList.new("#{$gb_dir}/#{$gb_clientlist}")
		name=clientlist.get_clientname
		@ipaddress=clientlist.get_ipaddress
		status=clientlist.get_status
		control=clientlist.get_control
		group=clientlist.get_group
		exam=clientlist.get_exam
		web=clientlist.get_web
		laulc=clientlist.get_laulc
		listlength=name.length
		#puts listlength  / @reihen
                @tab = Table.new(listlength /@reihen +1, @reihen, true )
        	@tab.set_column_spacings( 3 )
        	@tab.set_row_spacings( 3 )
		k = 0
        	i=0
        	j=0
		
        	while k < listlength do
        		j =0
        		#puts j 
        		#puts listlength
        		while j< @reihen && k < listlength do
                	number=k+1				
			if name[k] then
                		#buttonname=number.to_s+":"+name[k].to_s

				namekurz=name[k].to_s
				namekurz=namekurz[0..$gb_namelength.to_i]
                		buttonname=number.to_s+":"+namekurz
				buttonname=buttonname.rjust($gb_namelength.to_i)






				hbox = HBox.new( false, 0 )
				#icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
				
        			
				
				
				
				

        			#hbox.pack_start( icon, false, false, 10 )
				#hbox.add(icongreen)

        			label = Label.new(buttonname)
				label.set_width_chars($gb_namelength.to_i+4)
        			hbox.pack_start( label, false, false, 10 )
	        		#button = Button.new
	        		#button.add( hbox )				
				
		
				
                		@button1[ k ] = Button.new
				@button1[k].set_name( buttonname )
				#(buttonname )
                		
				tooltips = Tooltips.new
        			tooltips.set_tip( @button1[k], "#{@ipaddress[k]} \n #{web[k]} \n #{control[k]}\n #{group[k]}\n #{exam[k]}", "" )
                		if status[k].chomp=="off" then
                			@button1[k].modify_bg( StateType::NORMAL, @rot )
					iconred = Image.new("#{$gb_working_dir}/icons/point-red.png")
					hbox.add(iconred)
					
					
				elsif laulc[k].chomp =="laulcoff" then
                			@button1[k].modify_bg( StateType::NORMAL, @purpur )
					iconpurpur = Image.new("#{$gb_working_dir}/icons/point-purpur.png")
					hbox.add(iconpurpur)

				elsif exam[k].chomp =="examon" then
                			@button1[k].modify_bg( StateType::NORMAL, @yellow )
					iconyellow = Image.new("#{$gb_working_dir}/icons/point-yellow.png")
					hbox.add(iconyellow)	
			
				elsif control[k].chomp =="lockon" then
                			@button1[k].modify_bg( StateType::NORMAL, @gray )
					icongray = Image.new("#{$gb_working_dir}/icons/point-gray.png")
					hbox.add(icongray)
					
				elsif web[k].chomp =="weboff" then
                			@button1[k].modify_bg( StateType::NORMAL, @orange )
					iconorange = Image.new("#{$gb_working_dir}/icons/point-orange.png")
					hbox.add(iconorange)
				else	
                			@button1[k].modify_bg( StateType::NORMAL, @gruen )
					icongreen = Image.new("#{$gb_working_dir}/icons/point-green.png")
					hbox.add(icongreen)
                		end
                		#button.signal_connect( "clicked" ) do
                    		#	| widget |
                    		#	on_button_clicked( widget )
               			@button1[k].add( hbox )
				@button1[k].signal_connect( "button_press_event" ) do
                    		| widget, event |
                    		on_feld_button_press_event( widget, event )				
				end
                                             
                	@tab.attach( @button1[k], j, j + 1, i, i + 1 )
			end                	
			j +=1
                	k += 1 #dasselbe wie k = k + 1
                	end
                i +=1 
        	end
        	#label=Label.new("Number of Student-Clients: #{listlength}")
        	#@tab.attach( label, 0, 1, i, i + 1 )
        	@vbox.pack_start(@tab)
		@vbox.pack_start(@hbox1)
                self.show_all
                 sleep($gb_sleep.to_i)
            end
        end
    end # ende start_animation

	def on_button_clicked(w)
        	columns=w.label.split(":")
   		k=columns[0]
   		server=@ipaddress[k.to_i-1]
        	puts "Button " + w.label
        	#system ("./bash/start_vnc.sh #{server}& ")
    	end
    	
    	
     def on_feld_button_press_event( w,event )
	columns=w.name.split(":")
   	k=columns[0]
   	server=@ipaddress[k.to_i-1]
	#name=@name[k.to_i-1]
        #puts "Button " + w.label
        #system ("./bash/start_vnc.sh #{server}& ")
     	
#     	if event.button == 1 # linke Maustaste
#     	#puts "quat"+server
#     	quat_viewonly(server)
#     	end
     	
     if event.button == 3 || event.button == 1 #wenn rechte Maustaste gedrückt wurde
         menu = Menu.new

         menu_full = MenuItem.new( _("FullScreen-Viewonly") )
         menu_full.set_name( "full" )
         menu_full.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget,server )
         end
         menu.append( menu_full )

         menu_half = MenuItem.new( _("HalfScreen-Viewonly") )
         menu_half.set_name( "half" )
         menu_half.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget,server )
         end
         menu.append( menu_half )

	menu_quat = MenuItem.new( _("SmallScreen-Viewonly") )
         menu_quat.set_name( "quat" )
         menu_quat.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget,server )
         end
         menu.append( menu_quat )

	menu_full_access = MenuItem.new( _("FullScreen-Access") )
         menu_full_access.set_name( "full_access" )
         menu_full_access.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget,server )
         end

	menu.append(Gtk::SeparatorMenuItem.new)

         menu.append( menu_full_access )

         menu_half_access = MenuItem.new( _("HalfScreen-Access") )
         menu_half_access.set_name( "half_access" )
         menu_half_access.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget,server )
         end
         menu.append( menu_half_access )

	menu.append(Gtk::SeparatorMenuItem.new)

	menu_webclose = MenuItem.new( _("Web-Lock") )
         menu_webclose.set_name( "webclose" )
         menu_webclose.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget,server )
         end
         menu.append( menu_webclose )

	menu_webopen = MenuItem.new( _("Web-Unlock") )
         menu_webopen.set_name( "webopen" )
         menu_webopen.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget,server )
         end
         menu.append( menu_webopen )

	menu.append(Gtk::SeparatorMenuItem.new)

	menu_lock = MenuItem.new( _("Screen-Lock") )
         menu_lock.set_name( "lockclient" )
         menu_lock.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget,server )
         end
         menu.append( menu_lock )


	menu_unlock = MenuItem.new( _("Screen-Unlock") )
         menu_unlock.set_name( "unlockclient" )
         menu_unlock.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget,server )
         end
         menu.append( menu_unlock )

	menu.append(Gtk::SeparatorMenuItem.new)

	menu_delete = MenuItem.new( _("Delete-Student-Client") )
         menu_delete.set_name( "deleteclient" )
         menu_delete.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget,server)
         end
         menu.append( menu_delete )	
	
	#menu_logoff = MenuItem.new( "Logoff-Student" )
         #menu_logoff.set_name( "logoffstudent" )
         #menu_logoff.signal_connect( "activate" ) do
         #    | widget |
         #    on_menu_activate( widget,server)
         #end
         #menu.append( menu_logoff )

	 menu_powerdown = MenuItem.new( _("Powerdown-Student-Client") )
         menu_powerdown.set_name( "powerdownstudent" )
         menu_powerdown.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget,server)
         end
         menu.append( menu_powerdown )

	menu.show_all
         menu.popup( nil, nil, event.button, event.time )
     end
 end

 def on_menu_activate( w,ip )
     if w.name == "full"
         full(ip)
     elsif w.name == "half"
         half(ip)
     elsif w.name == "quat"
         quat(ip)
      elsif w.name == "full_access"
         full_access(ip)
     elsif w.name == "half_access"
         half_access(ip)
    elsif w.name == "webclose"
	webclose(ip)
    elsif w.name == "webopen"
	webopen(ip)
    elsif w.name == "lockclient"
	lockscreen(ip)
    elsif w.name == "unlockclient"
	unlockscreen(ip)
    elsif w.name == "deleteclient"
	deleteclient(ip)
    elsif w.name == "logoffstudent"
	logoff(ip)
     elsif w.name == "powerdownstudent"
	powerdown(ip)
    end
 end



	def deleteclient(ip)
		msg = _("The Client will be deleted from the table!")
        	#MessageDialog
        	dialog = MessageDialog.new( nil, 0, 1, 5, msg )
        	dialog.run do
            	|response|
            	if response == -5
			system("sed -i /#{ip}/d  #{$gb_dir}/#{$gb_clientlist}")
			prozess=`sudo ps ax|grep -w 'vncviewer #{ip}'|awk '{print $1}'`
			#puts prozess			
			system("sudo kill -9 #{prozess}")
                	dialog.destroy
               		 return false
                                                                     
            	elsif response == -6
                	dialog.destroy
               
                	return true
            	end
        	end	
	
	end
	
	
end #Ende class Fenster

#init
#ClientTable.new
#main
