#!/usr/bin/env ruby
 $LOAD_PATH.unshift File.dirname($PROGRAM_NAME)
 require 'gtk2'
 require 'get_global_list'
 include Gtk
require 'gettext'
include GetText
 
 bindtextdomain("config_dialog", :path => '/usr/local/bin/km/liveusbcontrol/locale') 
 class ConfigDialog < Window

     #Membervariablen
     @titel
     @filename
     @global
     @entry

     def initialize
        super
	@entry = Array.new
	self.signal_connect( "destroy" ) do
            		on_window_destroy
        end        
	
        #self.set_size_request( 250, 200 )
        #self.signal_connect( "destroy" ) { main_quit }
	self.set_modal(true)
        self.set_border_width( 3 )
	self.set_window_position( Position::CENTER )
	self.set_resizable( false )
	#get_global_list
	@filename="#{$gb_dir}/conf/global.rb"
	file=GetGlobalList.new(@filename)
	@global=file.get_globalcontent

        #MessageDialog
        msg = ""
        dialog = MessageDialog.new( self, 0, 2, 5, msg )
	icon = Image.new("#{$gb_working_dir}/icons/la-banner-preferences.png")
	icon.show	
	dialog.set_image(icon)
	
	#vbox.pack_start( icon )        
	#dialog.set_image(icon)
        frame1 = Frame.new
        frame1.set_label( "Files" )
	vbox1 = VBox.new(true,3)
	vbox1.set_border_width( 3 )
=begin      
        @entry[0] = Entry.new
        @entry[0].text="#{@global['$gb_working_dir'].chomp}"
        @entry[0].show
        hbox = HBox.new
        label = Label.new("Working-Directory : ")
        label.show
        hbox.add(label)
        hbox.add(@entry[0])
        hbox.show
        vbox1.add(hbox)
        #dialog.vbox.pack_start( hbox )
=end        
        @entry[1] = Entry.new
        @entry[1].text="#{@global['$gb_teacher_out'].chomp}"
        @entry[1].show
        hbox = HBox.new
        label = Label.new(_("Teacher-Out-Directory : "))
        label.show
        hbox.add(label)
        hbox.add(@entry[1])
        hbox.show
        vbox1.add(hbox)
        #dialog.vbox.pack_start( hbox )
        
        @entry[2] = Entry.new
        @entry[2].text="#{@global['$gb_teacher_in'].chomp}"
        @entry[2].show
        hbox = HBox.new
        label = Label.new(_("Teacher-In-Directory  : "))
        label.show
        hbox.add(label)
        hbox.add(@entry[2])
        hbox.show
        vbox1.add(hbox)
        #dialog.vbox.pack_start( hbox )
        
	@entry[3] = Entry.new
        @entry[3].text="#{@global['$gb_student_out'].chomp}"
        @entry[3].show
        hbox = HBox.new
        label = Label.new(_("Student-Out-Directory : "))
        label.show
        hbox.add(label)
        hbox.add(@entry[3])
        hbox.show
        vbox1.add(hbox)
        #dialog.vbox.pack_start( hbox )
        
        @entry[4] = Entry.new
        @entry[4].text="#{@global['$gb_student_in'].chomp}"
        @entry[4].show
        hbox = HBox.new
        label = Label.new(_("Student-In-Directory   : "))
        label.show
        hbox.add(label)
        hbox.add(@entry[4])
        hbox.show
        vbox1.add(hbox)
        #dialog.vbox.pack_start( hbox )
        

	@entry[17] = Entry.new
        @entry[17].text="#{@global['$gb_student_in_filter'].chomp}"
        @entry[17].show
        hbox = HBox.new
        label = Label.new(_("Student-In-Filter           : "))
        label.show
        hbox.add(label)
        hbox.add(@entry[17])
        hbox.show
        vbox1.add(hbox)
=begin
        @entry[5] = Entry.new
        @entry[5].text="#{@global['$gb_clientlist'].chomp}"
        @entry[5].show
        hbox = HBox.new
        label = Label.new("Clientlist-File : ")
        label.show
        hbox.add(label)
        hbox.add(@entry[5])
        hbox.show
        vbox1.add(hbox)
        vbox1.show
        #dialog.vbox.pack_start( hbox )
        
        @entry[6] = Entry.new
        @entry[6].text="#{@global['$gb_cmdlist'].chomp}"
        @entry[6].show
        hbox = HBox.new
        label = Label.new("C]ommandlist-File : ")
        label.show
        hbox.add(label)
        hbox.add(@entry[6])
        hbox.show
        vbox1.add(hbox)
        vbox1.show
        #dialog.vbox.pack_start( hbox )
        
        @entry[7] = Entry.new
        @entry[7].text="#{@global['$gb_cmdactual'].chomp}"
        @entry[7].show
        hbox = HBox.new
        label = Label.new("CmdActual-File : ")
        label.show
        hbox.add(label)
        hbox.add(@entry[7])
        hbox.show
        vbox1.add(hbox)
        vbox1.show
        #dialog.vbox.pack_start( hbox )
        
        
        @entry[8] = Entry.new
        @entry[8].text="#{@global['$gb_webactual'].chomp}"
        @entry[8].show
        hbox = HBox.new
        label = Label.new("WebActual-File : ")
        label.show
        hbox.add(label)
        hbox.add(@entry[8])
        hbox.show
        vbox1.add(hbox)
=end
        vbox1.show
        #dialog.vbox.pack_start( hbox )
        
        
        frame1.add(vbox1)
        frame1.show
        
        frame2 = Frame.new
        frame2.set_label( "Options" )
        vbox2 = VBox.new(false,3)
        vbox2.set_border_width( 3 )
        
	numbers = %w( 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 ) #Array
        @entry[9] = ComboBox.new
	numbers.each do |val|
  	@entry[9].append_text(val)
	end
	set="#{@global['$gb_sleep_ping_active'].chomp}"
	@entry[9].active = set.to_i	
	@entry[9].show









	#@entry[9] = Entry.new
	#@entry[9].text="#{@global['$gb_sleep'].chomp}"
        #@entry[9].show
        hbox = HBox.new
        label = Label.new(_("Refreshtime(s):                    "))
        label.show
        hbox.add(label)
        hbox.add(@entry[9])
        hbox.show
        vbox2.add(hbox)
        vbox2.show
        ##dialog.vbox.pack_start( hbox )
        
	#Timestamps
        #refresh = %w( 1 2 3 4 5 6 7 8 9 10 11 12 ) #Array
        #@entry[9] = Combo.new
        #@entry[9].set_size_request( 60, 30 )
	#@entry[9].entry
       	#@entry[9].set_popdown_strings( refresh )
	#@entry[9].show
        #hbox = HBox.new
        #label = Label.new("Refreshtime(s) : ")
        #label.show
        #hbox.add(label)
        #hbox.add(@entry[9])
        #hbox.show
        #vbox2.add(hbox)
        #vbox2.show

        
	numbers = %w( 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 ) #Array
        @entry[10] = ComboBox.new
	numbers.each do |val|
  	@entry[10].append_text(val)
	end
	set="#{@global['$gb_sleep_vnc_active'].chomp}"
	@entry[10].active = set.to_i	
	@entry[10].show
	
	#@entry[10] = Entry.new
        #@entry[10].text="#{@global['$gb_sleep_vnc'].chomp}"
        #@entry[10].show
        hbox = HBox.new	                  
        label = Label.new(_("Remote-VNC-Wait(s):           "))
        label.show
        hbox.add(label)
        hbox.add(@entry[10])
        hbox.show
        vbox2.add(hbox)



	numbers = %w( 1 2 3 4 5 6 7 8 9 10 ) #Array
        @entry[11] = ComboBox.new
	numbers.each do |val|
  	@entry[11].append_text(val)
	end
	set="#{@global['$gb_connect_time_active'].chomp}"
	@entry[11].active = set.to_i	
	@entry[11].show
	
	hbox = HBox.new	                  
        label = Label.new(_("SSH-Connect-Time(s):           "))
        label.show
        hbox.add(label)
        hbox.add(@entry[11])
        hbox.show
        vbox2.add(hbox)
        #dialog.vbox.pack_start( hbox )
=begin        
        @entry[11] = Entry.new
        @entry[11].text="#{@global['$gb_sleep_ping'].chomp}"
        @entry[11].show
        hbox = HBox.new
        label = Label.new("Ping-Wait: ")
        label.show
        hbox.add(label)
        hbox.add(@entry[11])
        hbox.show
        vbox2.add(hbox)
        #dialog.vbox.pack_start( hbox )
=end        
        label = Label.new
        label.show
        #vbox2.add(label)
        #vbox2.show
        #dialog.vbox.pack_start( hbox )
        


	numbers = %w( 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 ) #Array
        @entry[12] = ComboBox.new
	numbers.each do |val|
  	@entry[12].append_text(val)
	end
	set="#{@global['$gb_reihen_active'].chomp}"
	@entry[12].active = set.to_i	
	@entry[12].show

	#@entry[12] = Entry.new
        #@entry[12].text="#{@global['$gb_reihen'].chomp}"
        #@entry[12].show
        hbox = HBox.new
        label = Label.new(_("Number of Students columns:  "))
        label.show
        hbox.add(label)
        hbox.add(@entry[12])
        hbox.show
        vbox2.add(hbox)
        #dialog.vbox.pack_start( hbox )


#icon_size
	numbers = %w( 22 32 50 ) #Array
        @entry[21] = ComboBox.new
	numbers.each do |val|
  	@entry[21].append_text(val)
	end
	set="#{@global['$gb_icon_size_active'].chomp}"
	@entry[21].active = set.to_i	
	@entry[21].show

	#@entry[12] = Entry.new
        #@entry[12].text="#{@global['$gb_reihen'].chomp}"
        #@entry[12].show
        hbox = HBox.new
        label = Label.new(_("Iconsize of the Main-LATS:  "))
        label.show
        hbox.add(label)
        hbox.add(@entry[21])
        hbox.show
        vbox2.add(hbox)


#icon_size
	numbers = %w( vertical horizontal ) #Array
        @entry[22] = ComboBox.new
	numbers.each do |val|
  	@entry[22].append_text(val)
	end
	set="#{@global['$gb_icon_type_active'].chomp}"
	@entry[22].active = set.to_i
	@entry[22].show

	#@entry[12] = Entry.new
       #@entry[12].text="#{@global['$gb_reihen'].chomp}"
        #@entry[12].show
        hbox = HBox.new
        label = Label.new(_("Main-LATS-Type:  "))
        label.show
        hbox.add(label)
        hbox.add(@entry[22])
        hbox.show
        vbox2.add(hbox)





#screensaver
	hbox = HBox.new
        label = Label.new(_("Screencontrol:             "))
        label.show
        hbox.add(label)
	screen = %w( vbetool xrandr xlock ) #Array
        #screen = %w( blank deluxe star strange splines eyes pyro sphere rain laser image ) #Array
        @combo_screen = Gtk::ComboBox.new
	screen.each do |val|
  	@combo_screen.append_text(val)
	end
	set="#{@global['$gb_screen_active'].chomp}"
	@combo_screen.active = set.to_i
        


	@combo_screen.show
        hbox.add(@combo_screen)
	hbox.show
        vbox2.add(hbox)  

	label = Label.new
        label.show
        #vbox2.add(label)
        #vbox2.show
        #dialog.vbox.pack_start( hbox )
        
	numbers = %w( 3128 8080 ) #Array
        @entry[13] = ComboBoxEntry.new
	
	testing="#{@global['$gb_proxy_port_active'].chomp}"
	if testing == "-1" 
		number="#{@global['$gb_proxy_port'].chomp}"
		@entry[13].append_text(number)
		@entry[13].active = 0
		numbers.each do |val|
  		@entry[13].append_text(val)
		end
	else	
		numbers.each do |val|
  		@entry[13].append_text(val)
		end
		set="#{@global['$gb_proxy_port_active'].chomp}"
		@entry[13].active = set.to_i	
	end
	
		
	@entry[13].show

	#@entry[13] = Entry.new
        #@entry[13].text="#{@global['$gb_proxy_port'].chomp}"
        #@entry[13].show
        hbox = HBox.new
        label = Label.new(_("  Proxy Port:"))
        label.show
        hbox.add(label)
        hbox.add(@entry[13])
        hbox.show
        vbox2.add(hbox)
        
	@entry[20] = Entry.new
        @entry[20].text="#{@global['$gb_exception_ports'].chomp}"
        @entry[20].show
        hbox = HBox.new
        label = Label.new(_("   Exam_Close_Ports: "))
        label.show
        hbox.add(label)
        hbox.add(@entry[20])
        hbox.show
        vbox2.add(hbox)
	      


	k=0
	while k < 1 do        
		label = Label.new
        	label.show
        	vbox2.add(label)
		k +=1
	end
        #vbox2.show
        #dialog.vbox.pack_start( hbox )
        
        frame2.add(vbox2)
        frame2.show

        frame3 = Frame.new
        frame3.set_label( "SSH" )
        vbox3 = VBox.new(false,3)
        vbox3.set_border_width( 3 )
        
#@entry[13] = Entry.new
#        @entry[13].text="#{$gb_live_user}"
#        @entry[13].show
#        hbox = HBox.new(false,0)
#        label = Label.new("        SSH-Username: ")
#        label.show
#        hbox.add(label)
#        hbox.add(@entry[13])
#        hbox.show
#        vbox3.add(hbox)
        #dialog.vbox.pack_start( hbox )
        
#        @entry[14] = Entry.new
#        @entry[14].text="#{$gb_live_passwd}"
#	@entry[14].set_visibility(true)
#        @entry[14].show
#        hbox = HBox.new(false,0)
#        label = Label.new("   Student-Password:  ")
#        label.show
#        hbox.add(label)
#        hbox.add(@entry[14])
#        hbox.show
#        vbox3.add(hbox)
#        vbox3.show
        #dialog.vbox.pack_start( hbox )
        
#        @entry[15] = Entry.new
#       @entry[15].text="#{$gb_live_root_passwd}"
#	@entry[15].set_visibility(false)
#        @entry[15].show
#        hbox = HBox.new(false,0)
#        label = Label.new(" SSH-Root-Password: ")
#        label.show
#        hbox.add(label)
#        hbox.add(@entry[15])
#        hbox.show
#        vbox3.add(hbox)
#        vbox3.show
        #dialog.vbox.pack_start( hbox )
        
        
        @entry[16] = Entry.new
        @entry[16].text="#{$gb_laulc_password}"
	@entry[16].set_visibility(false)        
	@entry[16].show
	hbox = HBox.new(false,0)
        label = Label.new(_("LA-Control-Password: "))
        label.show
	hbox.add(label)
        hbox.add(@entry[16])
        hbox.show
        vbox3.add(hbox)
	vbox3.show
        #dialog.vbox.pack_start( hbox )
        frame3.add(vbox3)
        frame3.show
        
        
        hbox2 = HBox.new(false,5)
        hbox2.add(frame1)
        hbox2.add(frame2)
        hbox2.show
        
        
        
        
        dialog.vbox.pack_start(hbox2)
        dialog.vbox.pack_start(frame3)
        dialog.run do
            | response |
            if response == -5
                #file=GetGlobalList.new("#{$gb_dir}/~/.laulc/conf/global.rb")
		#@global['$gb_working_dir']="#{@entry[0].text}"
		@global['$gb_working_dir']="#{$gb_working_dir}"
		@global['$gb_teacher_out']="#{@entry[1].text}"
		@global['$gb_teacher_in']="#{@entry[2].text}"
		@global['$gb_student_out']="#{@entry[3].text}"
		@global['$gb_student_in']="#{@entry[4].text}"
		#@global['$gb_clientlist']="#{@entry[5].text}"
		#@global['$gb_cmdlist']="#{@entry[6].text}"
		#@global['$gb_cmdactual']="#{@entry[7].text}"
		#@global['$gb_webactual']="#{@entry[8].text}"
		@global['$gb_clientlist']="#{$gb_clientlist}"
		@global['$gb_cmdlist']="#{$gb_cmdlist}"
		@global['$gb_cmdactual']="#{$gb_cmdactual}"
		@global['$gb_webactual']="#{$gb_webactual}"

		@global['$gb_sleep']="#{@entry[9].active_text}"
		@global['$gb_sleep_vnc']="#{@entry[10].active_text}"
		@global['$gb_sleep_vnc_active']="#{@entry[10].active}"
		
		@global['$gb_connect_time']="#{@entry[11].active_text}"
		@global['$gb_connect_time_active']="#{@entry[11].active}"
		
		@global['$gb_sleep_ping']="#{@entry[9].active_text}"
		@global['$gb_sleep_ping_active']="#{@entry[9].active}"
		
		@global['$gb_reihen']="#{@entry[12].active_text}"
		@global['$gb_reihen_active']="#{@entry[12].active}"
		@global['$gb_live_user']="#{$gb_live_user}"
		#@global['$gb_live_passwd']="#{@entry[14].text}"
		@global['$gb_live_passwd']="#{$gb_live_passwd}"
		@global['$gb_live_root_passwd']="#{$gb_root_password}"
		@global['$gb_laulc_password']="#{@entry[16].text}"
		@global['$gb_student_in_filter']="#{@entry[17].text}"
		@global['$gb_proxy_port']="#{@entry[13].active_text}"
		@global['$gb_proxy_port_active']="#{@entry[13].active}"
		@global['$gb_dir']="#{$gb_dir}"
		@global['$gb_laulc_user']="laulc"
		@global['$gb_screen']="#{@combo_screen.active_text}"
		@global['$gb_screen_active']="#{@combo_screen.active}"
		@global['$gb_exception_ports']="#{@entry[20].text}"
		@global['$gb_icon_size']="#{@entry[21].active_text}"
		@global['$gb_icon_size_active']="#{@entry[21].active}"
		@global['$gb_icon_type']="#{@entry[22].active_text}"
		@global['$gb_icon_type_active']="#{@entry[22].active}"
		#@global.each do
		#	|content|
		#	#puts content[0].to_s+":"+content[1].to_s	
		#end	
		file.set_globalcontent(@global)  
                      dialog.destroy 
		load "#{$gb_dir}/conf/global.rb"		
		#neustart
			#self.destroy                  
               elsif response == -6
                dialog.destroy
		#self.destroy
            end
        end
        
    end

	def neustart
	
	
	msg = _("A Restart is necessary!!")
        dialog = MessageDialog.new( self, 0, 2, 1, msg )
	dialog.run
	dialog.destroy
	main_quit
	end


        





end

#init
##puts $0
#ConfigDialog.new
#main
