#!/usr/bin/env ruby
 $LOAD_PATH.unshift File.dirname($PROGRAM_NAME)
require 'gtk2'
 require 'get_global_list'
include Gtk
require 'gettext'
include GetText
 
 bindtextdomain("configdialog-notebook", :path => '/usr/local/bin/km/liveusbcontrol/locale') 



class ConfigDialog < Window
		
	@filename
	@global
	@entry
	
	def initialize
        	super
		
		@entry = Array.new
		@filename="#{$gb_dir}/conf/global.rb"
		file=GetGlobalList.new(@filename)
		@global=file.get_globalcontent

	
		self.set_modal(true)
        	self.set_border_width( 3 )
		self.set_window_position( Position::CENTER )
		self.set_title("Preferences")
		self.signal_connect( "destroy" ) do
            		self.destroy
		end

		
		
		frame1 = Frame.new
        	frame1.set_label( "Files" )
		vboxframe1 = VBox.new(true,3)
		vboxframe1.set_border_width( 3 )

		
		@entry[1] = Entry.new
        	@entry[1].text="#{@global['$gb_teacher_out'].chomp}"
        	@entry[1].show
        	hbox = HBox.new
        	label = Label.new(_("Teacher-Out-Directory : "))
        	label.show
        	hbox.add(label)
       		hbox.add(@entry[1])
        	hbox.show
        	vboxframe1.add(hbox)
		vboxframe1.show
        
		@entry[2] = Entry.new
        	@entry[2].text="#{@global['$gb_teacher_in'].chomp}"
        	@entry[2].show
        	hbox = HBox.new
        	label = Label.new(_("Teacher-In-Directory  : "))
        	label.show
        	hbox.add(label)
        	hbox.add(@entry[2])
        	hbox.show
        	vboxframe1.add(hbox)

		@entry[3] = Entry.new
        	@entry[3].text="#{@global['$gb_student_out'].chomp}"
        	@entry[3].show
        	hbox = HBox.new
        	label = Label.new(_("Student-Out-Directory : "))
        	label.show
        	hbox.add(label)
        	hbox.add(@entry[3])
        	hbox.show
        	vboxframe1.add(hbox)

		@entry[4] = Entry.new
        	@entry[4].text="#{@global['$gb_student_in'].chomp}"
        	@entry[4].show
        	hbox = HBox.new
        	label = Label.new(_("Student-In-Directory   : "))
        	label.show
        	hbox.add(label)
        	hbox.add(@entry[4])
        	hbox.show
        	vboxframe1.add(hbox)

		@entry[17] = Entry.new
        	@entry[17].text="#{@global['$gb_student_in_filter'].chomp}"
        	@entry[17].show
        	hbox = HBox.new
        	label = Label.new(_("Student-In-Filter           : "))
        	label.show
        	hbox.add(label)
        	hbox.add(@entry[17])
        	hbox.show
        	vboxframe1.add(hbox)

		frame1.add(vboxframe1)
        	frame1.show
		
		frame2 = Frame.new
        	frame2.set_label( "Options" )
        	vboxframe2 = VBox.new(false,3)
        	vboxframe2.set_border_width( 3 )





	        

		frame2.add(vboxframe2)
        	frame2.show

		numbers = %w( 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 ) #Array
        	@entry[9] = ComboBox.new
		numbers.each do |val|
  			@entry[9].append_text(val)
		end
		set="#{@global['$gb_sleep_ping_active'].chomp}"
		@entry[9].active = set.to_i	
		@entry[9].show
	        hbox = HBox.new
	        label = Label.new(_("Refreshtime(s):                    "))
	        label.show
	        hbox.add(label)
	        hbox.add(@entry[9])
	        hbox.show
	        vboxframe2.add(hbox)
        	vboxframe2.show

		numbers = %w( 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 ) #Array
        	@entry[10] = ComboBox.new
		numbers.each do |val|
  			@entry[10].append_text(val)
		end
		set="#{@global['$gb_sleep_vnc_active'].chomp}"
		@entry[10].active = set.to_i	
		@entry[10].show
	       hbox = HBox.new	                  
        	label = Label.new(_("Remote-VNC-Wait(s):           "))
        	label.show
        	hbox.add(label)
        	hbox.add(@entry[10])
        	hbox.show
        	vboxframe2.add(hbox)


		numbers = %w( 1 2 3 4 5 6 7 8 9 10 ) #Array
        	@entry[11] = ComboBox.new
		numbers.each do |val|
  			@entry[11].append_text(val)
		end
		set="#{@global['$gb_connect_time_active'].chomp}"
		@entry[11].active = set.to_i	
		@entry[11].show
		hbox = HBox.new	                  
        	label = Label.new(_("SSH-Connect-Time(s):           "))
        	label.show
        	hbox.add(label)
        	hbox.add(@entry[11])
        	hbox.show
        	vboxframe2.add(hbox)


		
		hbox = HBox.new
        	label = Label.new(_("Screencontrol:             "))
        	label.show
        	hbox.add(label)
		screen = %w( xlock vbetool xrandr  ) #Array
                @combo_screen = Gtk::ComboBox.new
		screen.each do |val|
  			@combo_screen.append_text(val)
		end
		set="#{@global['$gb_screen_active'].chomp}"
		@combo_screen.active = set.to_i
        	@combo_screen.show
        	hbox.add(@combo_screen)
		hbox.show
        	vboxframe2.add(hbox) 


		hbox = HBox.new
        	label = Label.new(_("IN-OUT-delete:             "))
        	label.show
        	hbox.add(label)
		screen = %w( no yes ) #Array
                @combo_in_out = Gtk::ComboBox.new
		screen.each do |val|
  			@combo_in_out.append_text(val)
		end
		set="#{@global['$gb_in_out_parameter_active'].chomp}"
		@combo_in_out.active = set.to_i
        	@combo_in_out.show
        	hbox.add(@combo_in_out)
		hbox.show
        	vboxframe2.add(hbox) 




		label = Label.new
        	label.show
        	numbers = %w( 3128 8080 ) #Array
        	@entry[13] = ComboBoxEntry.new
		testing="#{@global['$gb_proxy_port_active'].chomp}"
		if testing == "-1" 
			number="#{@global['$gb_proxy_port'].chomp}"
			@entry[13].append_text(number)
			@entry[13].active = 0
			numbers.each do |val|
  				@entry[13].append_text(val)
			end
		else	
			numbers.each do |val|
  				@entry[13].append_text(val)
			end
			set="#{@global['$gb_proxy_port_active'].chomp}"
			@entry[13].active = set.to_i	
		end
		@entry[13].show

		hbox = HBox.new
        	label = Label.new(_("  Proxy Port:"))
        	label.show
        	hbox.add(label)
        	hbox.add(@entry[13])
        	hbox.show
        	#vboxframe2.add(hbox)

		@entry[20] = Entry.new
        	@entry[20].text="#{@global['$gb_exception_ports'].chomp}"
        	@entry[20].show
        	hbox = HBox.new
        	label = Label.new(_("   Exam_Close_Ports: "))
        	label.show
        	hbox.add(label)
        	hbox.add(@entry[20])
        	hbox.show
        	#vboxframe2.add(hbox)



		frame3 = Frame.new
        	frame3.set_label( "SSH" )
        	vboxframe3 = VBox.new(false,3)
        	vboxframe3.set_border_width( 3 )

		@entry[16] = Entry.new
        	@entry[16].text="#{$gb_laulc_password}"
		@entry[16].set_visibility(false)        
		@entry[16].show
		hbox = HBox.new(false,0)
        	label = Label.new(_("LA-Control-Password: "))
        	label.show
		hbox.add(label)
        	hbox.add(@entry[16])
        	hbox.show
        	vboxframe3.add(hbox)
		vboxframe3.show

		numbers = %w( off on ) #Array
        	@entry[40] = ComboBox.new
		numbers.each do |val|
  			@entry[40].append_text(val)
		end
		set="#{@global['$gb_debug_active'].chomp}"
		@entry[40].active = set.to_i
	        hbox = HBox.new
        	label = Label.new(_("Debug-Modus:  "))
        	label.show
        	hbox.add(label)
        	hbox.add(@entry[40])
        	hbox.show
        	vboxframe3.add(hbox)



        
	        frame3.add(vboxframe3)
	        frame3.show


		frame4 = Frame.new
        	frame4.set_label( _("Design") )
        	vboxframe4 = VBox.new(false,3)
        	vboxframe4.set_border_width( 3 )

		numbers = %w( 22 32 50 ) #Array
        	@entry[21] = ComboBox.new
		numbers.each do |val|
  			@entry[21].append_text(val)
		end
		set="#{@global['$gb_icon_size_active'].chomp}"
		@entry[21].active = set.to_i	
		@entry[21].show
		hbox = HBox.new
        	label = Label.new(_("Iconsize of the Main-LATS:  "))
        	label.show
        	hbox.add(label)
        	hbox.add(@entry[21])
        	hbox.show
        	vboxframe4.add(hbox)

		numbers = %w( vertical_left vertical_right horizontal_bottom horizontal_top ) #Array
        	@entry[22] = ComboBox.new
		numbers.each do |val|
  			@entry[22].append_text(val)
		end
		set="#{@global['$gb_icon_type_active'].chomp}"
		@entry[22].active = set.to_i
	        hbox = HBox.new
        	label = Label.new(_("Main-LATS-Type:  "))
        	label.show
        	hbox.add(label)
        	hbox.add(@entry[22])
        	hbox.show
        	vboxframe4.add(hbox)


		numbers = %w( 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 ) #Array
        	@entry[12] = ComboBox.new
		numbers.each do |val|
  			@entry[12].append_text(val)
		end
		set="#{@global['$gb_reihen_active'].chomp}"
		@entry[12].active = set.to_i	
		@entry[12].show
	        hbox = HBox.new
	        label = Label.new(_("Number of Studentlist columns:  "))
	        label.show
	        hbox.add(label)
	        hbox.add(@entry[12])
	        hbox.show
	        vboxframe4.add(hbox)

		numbers = %w( horizontal_bottom horizontal_top ) #Array
        	@entry[30] = ComboBox.new
		numbers.each do |val|
  			@entry[30].append_text(val)
		end
		set="#{@global['$gb_student_position_active'].chomp}"
		@entry[30].active = set.to_i	
		@entry[12].show
	        hbox = HBox.new
	        label = Label.new(_("Studentlist Type:  "))
	        label.show
	        hbox.add(label)
	        hbox.add(@entry[30])
	        hbox.show
	        vboxframe4.add(hbox)

		numbers = %w( 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 ) #Array
        	@entry[50] = ComboBox.new
		numbers.each do |val|
  			@entry[50].append_text(val)
		end
		set="#{@global['$gb_namelength'].chomp}"
		@entry[50].active = set.to_i	
		@entry[50].show
	        hbox = HBox.new
	        label = Label.new(_("Maximal Length of Student-Names:  "))
	        label.show
	        hbox.add(label)
	        hbox.add(@entry[50])
	        hbox.show
	        vboxframe4.add(hbox)




		frame4.add(vboxframe4)
	        frame4.show





		nb  = Gtk::Notebook.new
		nb.append_page(l1=frame1,Label.new("Files"))
		nb.append_page(l2=frame2, Gtk::Label.new(_("Options")))
		#nb.append_page(l3=frame3, Gtk::Label.new(_("SSH/Debug")))
		nb.append_page(l3=frame4, Gtk::Label.new(_("Design")))
		#nb.set_tab_reorderable(l1, true)
		#nb.set_tab_reorderable(l2, true)
		#nb.set_tab_detachable(l1, true)
		#nb.set_tab_detachable(l2, true)
		#nb.set_tab_reorderable(l3, true)
		#nb.set_tab_detachable(l3, true)
		#nb.set_group_id(0)


		
		vbox0=VBox.new
		icon = Image.new("#{$gb_working_dir}/icons/la-banner-preferences.png")
		icon.show
		vbox0.pack_start(icon)
		vbox0.add(nb)
	
		hbox1=HBox.new
		btnok = Button.new( Stock::OK )
        	btnok.signal_connect( "clicked" ) { on_OK_clicked }
        	btncancel = Button.new( Stock::CANCEL )
        	btncancel.signal_connect( "clicked" ) { on_cancel_clicked }		
		label=Label.new("                                     ")
		label.show    
		hbox1.pack_start(label)
		hbox1.add(btncancel)	
		hbox1.add(btnok)
		vbox0.add(hbox1)
		
		self.add(vbox0)
		
		def on_cancel_clicked
			self.destroy
		end
   
		def on_OK_clicked
					
			@global['$gb_working_dir']="#{$gb_working_dir}"
			@global['$gb_teacher_out']="#{@entry[1].text}"
			@global['$gb_teacher_in']="#{@entry[2].text}"
			@global['$gb_student_out']="#{@entry[3].text}"
			@global['$gb_student_in']="#{@entry[4].text}"
			#@global['$gb_clientlist']="#{@entry[5].text}"
			#@global['$gb_cmdlist']="#{@entry[6].text}"
			#@global['$gb_cmdactual']="#{@entry[7].text}"
			#@global['$gb_webactual']="#{@entry[8].text}"
			@global['$gb_clientlist']="#{$gb_clientlist}"
			@global['$gb_cmdlist']="#{$gb_cmdlist}"
			@global['$gb_cmdactual']="#{$gb_cmdactual}"
			@global['$gb_webactual']="#{$gb_webactual}"

			@global['$gb_sleep']="#{@entry[9].active_text}"
			@global['$gb_sleep_vnc']="#{@entry[10].active_text}"
			@global['$gb_sleep_vnc_active']="#{@entry[10].active}"
		
			@global['$gb_connect_time']="#{@entry[11].active_text}"
			@global['$gb_connect_time_active']="#{@entry[11].active}"
		
			@global['$gb_sleep_ping']="#{@entry[9].active_text}"
			@global['$gb_sleep_ping_active']="#{@entry[9].active}"
		
			@global['$gb_reihen']="#{@entry[12].active_text}"
			@global['$gb_reihen_active']="#{@entry[12].active}"
			@global['$gb_live_user']="#{$gb_live_user}"
			#@global['$gb_live_passwd']="#{@entry[14].text}"
			@global['$gb_live_passwd']="#{$gb_live_passwd}"
			@global['$gb_live_root_passwd']="#{$gb_root_password}"
			@global['$gb_laulc_password']="#{@entry[16].text}"
			@global['$gb_student_in_filter']="#{@entry[17].text}"
			@global['$gb_proxy_port']="#{@entry[13].active_text}"
			@global['$gb_proxy_port_active']="#{@entry[13].active}"
			@global['$gb_dir']="#{$gb_dir}"
			@global['$gb_laulc_user']="laulc"
			@global['$gb_screen']="#{@combo_screen.active_text}"
			@global['$gb_screen_active']="#{@combo_screen.active}"
			@global['$gb_in_out_parameter']="#{@combo_in_out.active_text}"
			@global['$gb_in_out_parameter_active']="#{@combo_in_out.active}"
			@global['$gb_exception_ports']="#{@entry[20].text}"
			@global['$gb_icon_size']="#{@entry[21].active_text}"
			@global['$gb_icon_size_active']="#{@entry[21].active}"
			@global['$gb_icon_type']="#{@entry[22].active_text}"
			@global['$gb_icon_type_active']="#{@entry[22].active}"
			@global['$gb_student_position_active']="#{@entry[30].active}"
			@global['$gb_student_position']="#{@entry[30].active_text}"
			@global['$gb_debug']="#{@entry[40].active}"
			@global['$gb_debug_active']="#{@entry[40].active_text}"
			@global['$gb_namelength']="#{@entry[50].active}"
			@global['$gb_namelength_active']="#{@entry[50].active_text}"
			#@global.each do
			#	|content|
			#	#puts content[0].to_s+":"+content[1].to_s	
			#end	
			file1=GetGlobalList.new(@filename)
			file1.set_globalcontent(@global)  
			load "#{$gb_dir}/conf/global.rb"
                      self.destroy 
			info_message
		end


		def info_message
			msg = _("Changes will be applied after a restart?") 
        	        dialog = MessageDialog.new( nil, 0,1,1, msg )
			
			dialog.run    		
			dialog.destroy
        	end   #info_message ende
			
		
	self.show_all
	
	end #def initilize
end #xclass Window



#init
#ConfigDialog.new
#main

