    #!/usr/bin/env ruby

require 'gtk2'
include Gtk

class Fenster < Window

     def initialize
          super
          self.signal_connect( "destroy" ) { main_quit }

          btn_info = Button.new( "Info" )
          btn_info.signal_connect( "clicked" ) { on_btn_info_clicked }
          self.add( btn_info )

          self.show_all

     end

     def on_btn_info_clicked
          a = AboutDialog.new
          a.artists = ["Grafiker 1 <no1@abc>", "Grafiker 2 <no2@abc>"]
          a.authors = ["Programmautor 1 <no1@abc>", "Programmautor 2 <no2@abc>"]
          a.comments = "Beispiel fr einen AboutDialog"
          a.copyright = "Copyright (C) 2005 Franz Burgmann"
          a.documenters = ["Documenter 1 <no1@abc>", "Documenter 2 <no2@abc>"]
          a.license = "Lizenzbestimmungen"
          a.logo = Gdk::Pixbuf.new( "bild.png" )
          a.name = "AboutDialog-Beispiel"
          a.translator_credits = "bersetzer 1 <no1@abc>\nbersetzer 2 <no2@abc>"
          a.version = "0.1"
          a.website = "http://meine_webseite.abc"
                                                                                 
        a.website_label = "Titel der Webseite"

        a.set_modal( true )
        a.show_all
    end

end
