#!/usr/bin/env ruby

 require 'gtk2'
 include Gtk

 class Fenster < Window

     def initialize
         super

        self.set_title( "" )
        self.set_border_width( 20 )
        self.set_window_position( Position::MOUSE )
        self.signal_connect( "destroy" ) { main_quit }

        button = Button.new( "Datei oeffnen" )
        button.signal_connect( "clicked" ) { on_button_clicked }

        self.add( button )
        self.show_all
    end

    def on_button_clicked
        fs = FileSelection.new( "Datei oeffnen" )
        fs.set_modal( self )
        fs.ok_button.signal_connect( "clicked" ) do
            #puts "gewhlte Datei: #{ fs.filename }"
        end
        fs.cancel_button.signal_connect( "clicked" ) do
            fs.destroy
                                                                     
        end
        fs.show_all
    end

end
init
Fenster.new
main
