     #!/usr/bin/env ruby

 require 'gtk2'
 include Gtk

 class Fenster < Window

     #Membervariablen
     @kalender

     def initialize
         super

         self.set_border_width( 10 )
         self.signal_connect( "destroy" ) { main_quit }

         #Icon fuer das Fenster definieren
         icon = Gdk::Pixbuf.new( "duck.png" )
         self.set_icon( icon )

         vbox = VBox.new( false, 0 )

         @kalender = Calendar.new
         @kalender.set_day( 1 )
         @kalender.set_month( 0 )
         @kalender.set_year( 1905 )
         vbox.pack_start( @kalender, false, false, 10 )

         button = Button.new( Stock::OK )
         button.signal_connect( "clicked" ) { on_button_clicked }
         vbox.pack_start( button, false, false, 0 )

         self.add( vbox )
         self.show_all
     end

     def on_button_clicked
         tag = @kalender.day.to_s
         monat = @kalender.month.to_s
         jahr = @kalender.year.to_s
         #puts "Du bist am " + tag + "." + monat + "." + jahr + " geboren."
     end
end
