    require 'gtk2'
 include Gtk

 class Fenster < Window

     #Membervariablen
     @eb1
     @eb2
     @image
    @pos #aktuelle Position des Bildes

    def initialize
        super

        self.set_title( "" )
        self.signal_connect( "destroy" ) { main_quit }

        @image = Image.new( "duck.png" )
        @pos = "eb1"

        hbox = HBox.new( true, 0 )

        @eb1 = EventBox.new
        @eb1.set_name( "eb1" )
        @eb1.signal_connect( "button_press_event" ) do
            | widget, event |
            on_eb_button_press_event( widget )
        end
        hbox.pack_start( @eb1 )

        @eb2 = EventBox.new
        @eb2.set_name( "eb2" )
        @eb2.signal_connect( "button_press_event" ) do
            | widget, event |
            on_eb_button_press_event( widget )
        end
        hbox.pack_start( @eb2 )

        @eb1.add( @image )

                                                           
        self.add( hbox )
        self.show_all
    end

    def on_eb_button_press_event( w )
        if @pos == w.name
            if w.name == "eb1"
                @eb1.remove( @image )
                @eb2.add( @image )
                @pos = "eb2"
            else
                @eb2.remove( @image )
                @eb1.add( @image )
                @pos = "eb1"
            end
        end
    end

end
