    #!/usr/bin/env ruby

 require 'gtk2'
 include Gtk

 class Fenster < Window

     #Membervariablen
     @area
    @txt_x1; @txt_y1; @txt_x2; @txt_y2 #Entrys
    @x1; @y1; @x2; @y2 #Punkte

    def initialize
        super

        @x1 = 0
        @y1 = 0
        @x2 = 0
        @y2 = 0

        self.set_title( "" )
        self.maximize
        self.set_border_width( 20 )
        self.signal_connect( "destroy" ) { main_quit }

        vbox = VBox.new( false, 10 )

        #Eingabefelder
        @txt_x1 = Entry.new
        @txt_y1 = Entry.new
        @txt_x2 = Entry.new
        @txt_y2 = Entry.new

        tab = Table.new( 2, 8, false )
        tab.attach( Label.new( "x1" ), 0, 1, 0, 1 )
        tab.attach( @txt_x1, 1, 2, 0, 1 )

        tab.attach( Label.new( "y1" ), 0, 1, 1, 2 )
        tab.attach( @txt_y1, 1, 2, 1, 2 )

        tab.attach( Label.new( "x2" ), 2, 3, 0, 1 )
        tab.attach( @txt_x2, 3, 4, 0, 1 )

        tab.attach( Label.new( "y2" ), 2, 3, 1, 2 )
        tab.attach( @txt_y2, 3, 4, 1, 2 )
        #Eingabefelder Ende
                                                           

        vbox.pack_start( tab, false, false, 10 )

        #Button
        button = Button.new( "Start" )
        button.signal_connect( "clicked" ) { on_button_clicked }
        vbox.pack_start( button, false, false, 10 )

        #DrawingArea
        @area = DrawingArea.new
        @area.set_size_request( 250, 250 )
        @area.modify_fg( STATE_NORMAL, Gdk::Color.new( 0, 30000, 0 ) )
        @area.signal_connect( "expose_event" ) { on_area_expose_event }
        vbox.pack_start( @area )

        self.add( vbox )
        self.show_all
    end

    def on_button_clicked
        #Werte aus den Textfeldern uebernehmen
        @x1 = @txt_x1.text.to_i
        @y1 = @txt_y1.text.to_i
        @x2 = @txt_x2.text.to_i
        @y2 = @txt_y2.text.to_i
        #DrawingArea neu zeichnen
        @area.queue_draw
    end

    def on_area_expose_event
        gc = @area.style.fg_gc( @area.state )
        @area.window.draw_line( gc, @x1, @y1, @x2, @y2 )
    end

end
