    #!/usr/bin/env ruby

 require 'gtk2'
 include Gtk

 class Fenster < Window

    #Membervariablen
    @pb
   @entry
   @label

    def initialize
        super

        self.set_title( "" )
        self.set_border_width( 10 )
        self.signal_connect( "destroy" ) { main_quit }

        vbox = VBox.new( true, 0 )

        vbox.pack_start( Label.new( "Berechnung der n-ten Potenz von 2:" ) )

        @entry = Entry.new
        vbox.pack_start( @entry )

        button = Button.new( "berechne" )
        button.signal_connect( "clicked" ) { on_button_clicked }
        vbox.pack_start( button )

        @label = Label.new
        vbox.pack_start( @label )

        #ProgressBar
        @pb = ProgressBar.new
        #Farbe des ProgressBars aendern
        @pb.modify_bg( STATE_SELECTED, Gdk::Color.new( 50000, 0, 0 ) )
        vbox.pack_start( @pb )

        self.add( vbox )
        self.show_all
    end

    def on_button_clicked
        @label.set_label( "" )
        hz = @entry.text.to_i
        ergebnis = 1
        fortschritt = 1 / hz.to_f
        Thread.start do
            t1 = Time.now.to_f
            for i in 1..hz
                ergebnis = ergebnis * 2
                @pb.fraction = fortschritt

                #Fortschritt in Prozent in den ProgressBar einfuegen
                @pb.set_text( ( fortschritt * 100 ).to_i.to_s + "%" )
                fortschritt += 1 / hz.to_f
            end
                                                                               
            t2 = Time.now.to_f
            zeit = ( ( ( t2 - t1 ) * 100 ).to_i / 100.to_f ).to_s
            @label.set_label( "bentigte Zeit: " + zeit + " sec" )
        end
    end

end
init
Fenster.new
main

