     require 'gtk2'
 include Gtk

 class Fenster < Window

      #Membervariablen
      @lbl_anzeige
      @hsb

     def initialize
         super

         self.set_title( "" )
         self.signal_connect( "destroy" ) { main_quit }

         hbox = HBox.new( false, 10 )
         hbox.set_border_width( 20 )

         @hsb = HScrollbar.new
         @hsb.set_size_request( 300, 30 )
         @hsb.set_range( 0, 100 )
         @hsb.set_increments( 1, 10 )
         @hsb.set_value( 30 )
         @hsb.signal_connect( "value_changed" ) { on_hsb_value_changed }
         hbox.pack_start( @hsb )

         @lbl_anzeige = Label.new( "30.0" )
         @lbl_anzeige.set_size_request( 150, 30 )
         hbox.pack_start( @lbl_anzeige )

         self.add( hbox )
         self.show_all
     end

     def on_hsb_value_changed
         @lbl_anzeige.set_label( @hsb.value.to_s )
     end

end
