#!/usr/bin/env ruby

 require 'gtk2'
 include Gtk

 class Fenster < Window

     #Membervariablen
     @btn_start #Button Start
    @btn_start_handler_id #Handler-ID
    @signal_angeschlossen #boolsche Variable
    @btn_signal
                                                

    def initialize
        super

        self.set_title( "" )
        self.set_border_width( 10 )
        #self.set_size_request( 200, 50 )
        self.signal_connect( "destroy" ) { main_quit }

        @signal_angeschlossen = true

        hbox = HBox.new( true, 10 )

        @btn_start = Button.new( "Start" )
        @btn_start_handler_id = @btn_start.signal_connect( "clicked" ) do
            on_btn_start_clicked
        end
        hbox.pack_start( @btn_start )

        @btn_signal = Button.new( "Signal blockieren" )
        @btn_signal.signal_connect( "clicked" ) { on_btn_signal_clicked }
        hbox.pack_start( @btn_signal )

        self.add( hbox )
        self.show_all
    end

    def on_btn_start_clicked
        #puts "Start"
    end

    def on_btn_signal_clicked
        if @signal_angeschlossen
            @btn_start.signal_handler_block( @btn_start_handler_id )
            @signal_angeschlossen = false
            @btn_signal.set_label( "Signal freigeben" )
        else
            @btn_start.signal_handler_unblock( @btn_start_handler_id )
            @signal_angeschlossen = true
            @btn_signal.set_label( "Signal blockieren" )

        end
    end

end

init
Fenster.new
main
