     require 'gtk2'
 include Gtk

 class Kontakt
      attr_reader :name, :telefon

      #Membervariablen
      @name
      @telefon

     def initialize( name_, telefon_ )
         @name = name_
         @telefon = telefon_
     end
end

class Fenster < Window

     #Membervariablen
     @kontakte
     @item

     def initialize
         super
         self.signal_connect( "destroy" ) { main_quit }

         @kontakte = []
         @item = []

         vbox = VBox.new( false, 0 )

         btn_neu = Button.new( "Kontakt hinzufgen" )
         btn_neu.signal_connect( "clicked" ) { on_btn_neu_clicked }
         btn_neu.set_border_width( 10 )
         vbox.pack_start( btn_neu, false, false )

         @list_store = ListStore.new( String, String )
         view = TreeView.new( @list_store )
         view.reorderable = true

         #Spalte 1
         r1 = CellRendererText.new
         col1 = TreeViewColumn.new( "Name",r1 , :text => 0 )
         col1.sort_column_id = 0
         col1.clickable = true
         col1.resizable = true
         col1.reorderable = true
         view.append_column( col1 )

         #Spalte 2
         r2 = CellRendererText.new
         col2 = TreeViewColumn.new( "Telefon", r2, :text => 1 )
         col2.sort_column_id = 1
         col2.clickable = true
         col2.resizable = true
         col2.reorderable = true
                                                                       
        view.append_column( col2 )

        vbox.pack_start( view, true, true )
        self.add( vbox )
        self.show_all
    end

    def on_btn_neu_clicked
        text = "neuen Kontakt eingeben"
        dialog = MessageDialog.new( self, 0, 2, 5, text )
        tab = Table.new( 2, 2, true )
        tab.attach( Label.new( "Name " ), 0, 1, 0, 1 )
        txt_name = Entry.new
        tab.attach( txt_name, 1, 2, 0, 1 )
        tab.attach( Label.new( "Telefon " ), 0, 1, 1, 2 )
        txt_telefon = Entry.new
        tab.attach( txt_telefon, 1, 2, 1, 2 )
        dialog.vbox.pack_start( tab )
        dialog.show_all
        dialog.run do
            | response |
            if response == -5
                i = @kontakte.length
                @kontakte << Kontakt.new( txt_name.text, txt_telefon.text )
                @item[ i ] = @list_store.append
                @item[ i ][ 0 ] = @kontakte[ i ].name
                @item[ i ][ 1 ] = @kontakte[ i ].telefon
            end
        end
        dialog.destroy

    end

end
