#!/usr/bin/env ruby
require 'gtk2'
include Gtk
def item_cb(iid)
  #puts "Item ##{iid} selected."
end

# Create a toolbar with Cut, Copy, Paste and Select All
# toolbar items.
def create_toolbar(tb, ent)
   	hboxcut = HBox.new( false, 0 )

        icon = Image.new( "icons/camera.png" )
        hboxcut.pack_start( icon, false, false, 10 )

        label = Label.new( "drucken" )
        hboxcut.pack_start( label, false, false, 10 )

        #button = Button.new
        #button.add( hbox )
  
  
  
  cut = Gtk::ToolButton.new(icon,'text')
  #cut.set_label('text')
  #cut.set_icon_widget(icon)
  #cut = Gtk::ToolButton.new(Gtk::Stock::CUT)
  copy = Gtk::ToolButton.new(Gtk::Stock::COPY)
  paste = Gtk::ToolButton.new(Gtk::Stock::PASTE)
  selectall = Gtk::ToolButton.new(Gtk::Stock::SELECT_ALL)
  separator = Gtk::SeparatorToolItem.new

  toggle = Gtk::ToggleToolButton.new(Gtk::Stock::HOME)
  radio1 = Gtk::RadioToolButton.new("Sellect")
  radio2 = Gtk::RadioToolButton.new(radio1, "_Un-sellect")
  toggle.active = true

  menu_btt = Gtk::MenuToolButton.new(Gtk::Stock::OPEN)

  ilist = [ Gtk::MenuItem.new("Item 1"),
            Gtk::MenuItem.new("Item 2"),
            Gtk::MenuItem.new("Item 2")
  ]
  ilist[0].signal_connect('activate') { item_cb(1) }
  ilist[1].signal_connect('activate') { item_cb(2) }
  ilist[2].signal_connect('activate') { item_cb(3) }

  file_list_mn = Gtk::Menu.new
  file_list_mn.append(ilist[0])
  file_list_mn.append(ilist[1])
  file_list_mn.append(ilist[2])
  file_list_mn.show_all

  menu_btt.menu = file_list_mn

  separator.draw = true
  separator.expand = true

  tb.show_arrow = true
  tb.toolbar_style = Gtk::Toolbar::Style::BOTH

  # NOTE: tool-tips are only part of the deprecated interface ?!
  tb.insert(0, cut)
  tb.insert(1, copy)
  tb.insert(2, paste)
  tb.insert(3, selectall)
  tb.insert(4, separator)

  tb.insert(5, menu_btt)
  tb.insert(6, radio1)
  tb.insert(7, toggle)
  tb.insert(8, radio2)

  cut.signal_connect('clicked')       { ent.cut_clipboard }
  copy.signal_connect('clicked')      { ent.copy_clipboard }
  paste.signal_connect('clicked')     { ent.paste_clipboard }
  selectall.signal_connect('clicked') { select_all(ent) }
end

# Select all of the text in the GtkEditable.
def select_all(edit)
  # Gtk::Editable#select_region
  edit.select_region(0, -1)
end

window = Gtk::Window.new(Gtk::Window::TOPLEVEL)
window.resizable = true
window.decorated = true
window.title = "Toolbars"
window.border_width = 10
window.signal_connect('delete_event') { Gtk.main_quit }
window.set_size_request(375, -1)

entry   = Gtk::Entry.new
toolbar = Gtk::Toolbar.new
create_toolbar(toolbar, entry)

vbox = Gtk::VBox.new(false, 5)
vbox.pack_start_defaults(toolbar)
#vbox.pack_start_defaults(entry)

window.add(vbox)
window.show_all
Gtk.main

