#!/usr/bin/env ruby
  $LOAD_PATH.unshift File.dirname($PROGRAM_NAME)

require 'gtk2'
 require 'ip_get_cmd'
require 'client_data'
require 'create_laulc_user'
require 'teaching_stop_cmd'
 include Gtk

 class ClientEntry < Window

     #Membervariablen
     
     

    def initialize
        super
	self.title = "Add-Student-Client"
        
        self.signal_connect( "destroy" ) do
            on_window_destroy
        end

       def on_window_destroy
        #main_quit	     
	end

        #@w.set_size_request( 320, 160 )
        #@w.resizable = false
	self.set_border_width( 10 )
        self.set_window_position( Position::CENTER )
        self.set_resizable( false )


	@ip_self = get_self_ip.chomp
	@mac_self = get_self_mac(@ip_self).chomp
	@mask_self = get_self_mask.chomp
	

	# banner-icon
	icon = Image.new("#{$gb_working_dir}/icons/la-ts-client.png")
	


	#get teacher-network
	@iplist = @ip_self.split(".")
	if @mask_self == "255.255.255.0" then
		@teacher_ip=@iplist[0]+"."+@iplist[1]+"."+@iplist[2]+".xxx"
	elsif @mask_self == "255.255.0.0"
		@teacher_ip=@iplist[0]+"."+@iplist[1]+".xxx.yyy"
	elsif @mask_self == "255.0.0.0"
		@teacher_ip=@iplist[0]+".xxx.yyy.zzz"
	elsif @mask_self == "0.0.0.0"
		@teacher_ip="nnn.xxx.yyy.zzz"
	end
	
	#puts @ip_self	
        @hbox1 = HBox.new(false,10)
	@label1=Label.new("Teacher-IP:")
	@hbox1.add(@label1)
	@entry1 = Entry.new
        #@entry1.set_size_request( 160, 20 )
        @entry1.set_text( @teacher_ip)
	@hbox1.add(@entry1)

	 @hbox5 = HBox.new(false,10)
	@label5=Label.new("PIN-Code:    ")
	@hbox5.add(@label5)
	@entry5 = Entry.new
        #@entry1.set_size_request( 160, 20 )
        #@entry5.set_text( @teacher_ip)
	@hbox5.add(@entry5)

	@hbox2 = HBox.new(false,10)
	@label2=Label.new("Name:         ")
	@hbox2.add(@label2)
	@entry2 = Entry.new
        #@entry2.set_size_request( 160, 20 )
        @entry2.set_text("name")
	@hbox2.add(@entry2)
	
	#@hbox3 = HBox.new(false,10)
	#@label3=Label.new("IP-Address:")
	#label= Label.new( @ip_self )
	#@hbox3.add(@label3)
	#@hbox3.add(label)
	
	#@hbox4 = HBox.new(false,10)
	#@label4=Label.new("MAC-Address:")
	#label= Label.new( @mac_self )
	#@hbox4.add(@label4)
	#@hbox4.add(label)
	
	
	@vbox1=VBox.new(false,10)
	@vbox1.add(icon)	
	@vbox1.add( @hbox1)
	@vbox1.add( @hbox2)
	@vbox1.add(@hbox5)
	#@vbox1.add( @hbox3)
	#@vbox1.add( @hbox4)
			

	@btnok = Button.new( Stock::OK)
	@btnok_handler_id=@btnok.signal_connect( "clicked" ) do
            on_btnok_clicked
         end
	if @entry1.text == "" then	
	@btnok.signal_handler_block( @btnok_handler_id ) 
	@btnok.set_label( "No Network!!" )
	#puts "handler"	
	end		
	
        @btncancel = Button.new(Stock::CANCEL)
        @btncancel.signal_connect( "clicked" ) do
            on_cancel_clicked
         end
         
         label=Label.new("")
         hbox=HBox.new(false,10)
         hbox.add(label)
         hbox.add(@btncancel)
         hbox.add(@btnok)
         @vbox1.add(hbox)

	self.add(@vbox1)
        self.set_modal(true)
	self.set_decorated(true)
	self.resizable = false
	#self.set_has_frame(false)
        self.show_all
        
    end

    
    def on_btnok_clicked
	#puts "sshpass -p #{@entry5.text}  ssh -l #{$gb_live_user} #{@entry1.text}  'sudo #{$gb_working_dir}/client_remote_add.rb #{$gb_clientlist},client1,#{@entry2.text},#{@mac_self},#{@ip_self},on'"	
	rueckgabe=`sshpass -p #{@entry5.text}  ssh -l #{$gb_live_user} #{@entry1.text}  'sudo #{$gb_working_dir}/client_remote_add.rb #{$gb_clientlist},client1,#{@entry2.text},#{@mac_self},#{@ip_self},on'`	
	rueckgabe=rueckgabe.chomp
	#puts "HIER"+rueckgabe	
	if rueckgabe=="true" then
		msg = "Add-Client succeed!"
		#system("sudo hostname #{@entry2.text}")
		dialog = MessageDialog.new( self, 0, 2, 2, msg)
		dialog.run
		dialog.destroy
        
	elsif rueckgabe=="name_conflict" then 
		msg = "Add-Client failed! Name-Conflict"
		dialog = MessageDialog.new( self, 0, 2, 2, msg )
		dialog.run
		dialog.destroy
		self.destroy		
		main_quit
	elsif	rueckgabe=="ip_conflict" then 
		msg = "Add-Client failed! IP-Conflict"
		dialog = MessageDialog.new( self, 0, 2, 2, msg )
		dialog.run
		dialog.destroy
		self.destroy		
		main_quit
	end
	#dialog = MessageDialog.new( self, 0, 2, 2, msg )
	#dialog.run
	#dialog.destroy

	passwordwith="'"+@entry5.text+"'".chomp
	#puts passwordwith
	#system("sudo sed -i /gb_live_passwd/d  ~/.laulc/conf/global.rb")
	test=`sed -i '/$gb_live_passwd=/c $gb_live_passwd="#{passwordwith}"' ~/.laulc/conf/global.rb`	
	$gb_live_passwd=@entry5.text
	
	#system("sudo hostname #{@entry2.text}")
	password=`sshpass -p #{$gb_live_passwd}  ssh -l #{$gb_live_user} #{@entry1.text}  'sudo #{$gb_working_dir}/get_password.rb'`	
	password=password.chomp
	root_password=`sshpass -p #{$gb_live_passwd}  ssh -l #{$gb_live_user} #{@entry1.text}  'sudo #{$gb_working_dir}/get_root_password.rb'`	
	root_password=root_password.chomp
	laulc_user=`sshpass -p #{$gb_live_passwd}  ssh -l #{$gb_live_user} #{@entry1.text}  'sudo #{$gb_working_dir}/get_laulc_user.rb'`	
	laulc_user=laulc_user.chomp
	#puts root_password
	boxname=@entry2.text.chomp
	#puts "PASSWOED"+password
	#puts "LAULCUSER"+laulc_user
	#puts "create_laulc_user(#{password},#{laulc_user})"
	create_laulc_user(password,laulc_user)
	teaching_stop
	self.destroy
	main_quit
	
    end

    def on_cancel_clicked
	 self.destroy      
    end

end

init
ClientEntry.new
main
