#!/usr/bin/env ruby
  $LOAD_PATH.unshift File.dirname($PROGRAM_NAME)
require '~/.laulc/conf/global.rb'
 require 'gtk2'
require 'gtk2'
require 'latsmenue'
require 'client_entry' 
require 'client_data'
require 'show_ip_password'
require 'show_control_password'
require 'client_table'
require 'config_dialog'
require 'copy_checkbox'
require 'lock_checkbox'
require 'group_checkbox'
require 'cmd_checkbox'
require 'web_checkbox'
require 'vnc_radiobox'
require 'vnc_checkbox'
require 'power_checkbox'
require 'file_selection'
require '~/.laulc/conf/global'





require 'gettext'
include GetText
 bindtextdomain("latsmenue", :path => '/usr/local/bin/km/liveusbcontrol/locale') 
 include Gtk

class Latsmenue < Window

     #Membervariablen
    

    def initialize
        super
	
        
	#self.set_title( "LATS" )
        self.set_border_width( 0 )
	self.set_decorated(false)        
	#self.set_window_position( Position::LEFT )
	self.set_resizable( false )
	self.set_keep_above(true)
	self.move(5000,10000)
        self.signal_connect( "destroy" ) { main_quit }

	if $gb_icon_type =='vertical_left' then
		@vbox=VBox.new(false,0) 
		self.move(5,100)
	elsif $gb_icon_type =='vertical_right'
		@vbox=VBox.new(false,0) 
		self.set_gravity(Gdk::Window::GRAVITY_NORTH_EAST)
		self.move(Gdk.screen_width,5)
	elsif	$gb_icon_type =='horizontal_bottom'
		@vbox=HBox.new(false,0) 
		self.set_gravity(Gdk::Window::GRAVITY_SOUTH_WEST)
		self.move(5,Gdk.screen_height)
	else
		@vbox=HBox.new(false,0) 
		self.set_gravity(Gdk::Window::GRAVITY_NORTH_WEST)
		self.move(5,0)
	end	      
	
	icon = Image.new("#{$gb_working_dir}/icons/network-server.png")

	#button1 = Button.new
	#image1 = Image.new( Gtk::Stock::APPLY, 22)	
	#button1.set_image(image1)
	#button1.set_use_stock(true)
	#tooltips = Tooltips.new
        #tooltips.set_tip( button1, "test1", "") 
	#button1.signal_connect( "clicked" ) do
        #     on_button1_clicked				
	#end
	#@vbox.add(button1)

	def create_button(button1,stock1,tooltip,funktion1)
		
		button1 = Button.new
		image1 = Image.new(stock1)	
		button1.set_image(image1)
		button1.set_use_stock(true)
		tooltips = Tooltips.new
	        tooltips.set_tip( button1, tooltip,"")
		button1.signal_connect( "clicked" ) do
	             funktion1
		end			
		return button1	
	end
	box=create_button("Sort","#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Myspace-50.png",_('Watch-Student-Clients'), "on_sort_clicked" )       
	box.signal_connect( "clicked" ) do
	             on_sort_clicked
		end				
	@vbox.add(box)
	box=create_button("Connect","#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Key-50.png",_('Logon-Data'),"on_connect_info_clicked")   
	box.signal_connect( "clicked" ) do
	             on_connect_info_clicked
		end    
	@vbox.add(box)
	box=create_button("KillVnc","#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Invisible-50.png",_('VNC-Stop'),"on_killvnc_clicked")   
	box.signal_connect( "clicked" ) do
	            on_killvnc_clicked
		end    
	@vbox.add(box)
	box=create_button("GroupAB", "#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Group-50.png", _('Groups-A:B'),"on_group_clicked")
	box.signal_connect( "clicked" ) do
	            on_group_clicked
		end
	@vbox.add(box) 
	box=create_button("Webstop", "#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Domain-50.png", _('Lock/Unlock'),"on_webstop_clicked")
	box.signal_connect( "clicked" ) do
	            on_webstop_clicked
		end
	@vbox.add(box)
	box=create_button("View","#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Visible-50.png",_('View/Access'),"on_vnc_clicked")  
     	box.signal_connect( "clicked" ) do
	            on_vnc_clicked
		end
	@vbox.add(box)	
	box=create_button("Copy","#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Compare-50.png",_('Copy-IN-OUT)'),"on_copy_clicked") 
      	box.signal_connect( "clicked" ) do
	            on_copy_clicked
		end
	@vbox.add(box)	
	box=create_button("Exam", "#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Watch-50.png", _('Exam-Start'),"on_exam_clicked")
	box.signal_connect( "clicked" ) do
	           on_exam_clicked
		end
	@vbox.add(box) 
	box=create_button("Power", "#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Disconnected-50.png", _('Power-Control'),"on_power_clicked")
	box.signal_connect( "clicked" ) do
	          on_power_clicked
		end
	@vbox.add(box) 
	box=create_button("Preferences", "#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Settings-50.png", _('Preferences'),"on_preferences_clicked")
	box.signal_connect( "clicked" ) do
	         on_preferences_clicked
		end
	@vbox.add(box) 
	box=create_button("Rootpass","#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Password-50.png",_('Controlnummber'),"on_rootpass_clicked")   
    	box.signal_connect( "clicked" ) do
	         on_rootpass_clicked
		end
	@vbox.add(box)	
	box=create_button("Help","#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Help-50.png",_('Help'),"on_help_clicked")  
     	box.signal_connect( "clicked" ) do
	         on_help_clicked
		end
	@vbox.add(box)
	box=create_button("About","#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Info-50.png",_('About LATS'),"on_about_clicked")     
  	box.signal_connect( "clicked" ) do
	        on_about_clicked
		end
	@vbox.add(box)
	box=create_button("Quit","#{$gb_working_dir}/icons-new/#{$gb_icon_size}/Shutdown-50.png",_('Quit'),"on_quit_clicked")   
    	box.signal_connect( "clicked" ) do
	        on_quit_clicked
		end
	@vbox.add(box)
	
	#box=create_button("Test",Gtk::Stock::OK,"Testtooltip","on_connect_clicked")       
	#@vbox.add(box)	
	
	#box=create_button("Test",Gtk::Stock::APPLY,"Testtooltip","on_apply_clicked")       
	#@vbox.add(box)	
	
	
	
	
	

	
	

	def on_preferences_clicked
	#        fenster1=
	ConfigDialog.new
	#fenster1.show   
	end
	def on_rootpass_clicked
        fenster1=Show_control_password.new
	fenster1.show
	end

	def on_group_clicked
        fenster1=GroupCheckbox.new
	fenster1.show
	end

	def on_copy_clicked
        fenster1=CopyCheckbox.new
	fenster1.show   
	end

	def on_webstop_clicked
        fenster1=WebCheckbox.new
	fenster1.show   
	end

	def on_vnc_clicked
        fenster1=VNCCheckbox.new
	fenster1.show   
	end

	def on_power_clicked
        fenster1=PowerCheckbox.new
	fenster1.show   
	end

	def on_connect_clicked
        fenster1=VncRadiobox.new
	fenster1.show   
	end

	def on_exam_clicked
        fenster1=CmdCheckbox.new
	fenster1.show   
	end

	def on_apply_clicked
        fenster1=CmdCheckbox.new
	fenster1.show   
	end

	def on_killvnc_clicked
        msg = _("Do you want to stop the vnc-windows?") 
        #MessageDialog
        dialog = MessageDialog.new( nil, 0, 1, 4, msg )
        dialog.run do
            |response|
            if response == -8
		
			system("sudo killall vncviewer")
			system("sudo killall x11vnc")
			
                dialog.destroy
                #main_quit
                return false
                                                                     
            elsif response == -9
                dialog.destroy
               #main_quit
                return false
            end
        end
        #MessageDialog Ende
        
    	end



	def on_sort_clicked
		##puts "sort"
           clientlist=GetClientList.new("#{$gb_dir}/#{$gb_clientlist}")
	clientlist.sort_by_name("#{$gb_dir}/#{$gb_clientlist}")
	
	end

#def on_help_clicked
#        fenster1=Window.new("Help")
#	fenster1.set_border_width( 30 )
#	#fenster1.set_window_position(GTK::Position::CENTER)
#	label=Label.new("A help-tool is not included yet!")	
#	fenster1.add(label)
#	fenster1.show_all  
#end

	def on_help_clicked
         a = AboutDialog.new
	  a.program_name = _("Documentation")
	  #a.version = "-Help"
          #a.comments = "Lizenz: GPL2+"
          #a.copyright = "Copyright (C) 2010 Klaus Misof"
          #a.documenters = ["Documenter 1 <no1@abc>", "Documenter 2 <no2@abc>"]
           a.logo = Gdk::Pixbuf.new( "#{$gb_working_dir}/icons/dialog-question.png" )
          #a.name = "AboutDialog-Beispiel"
          #a.translator_credits = "Übersetzer 1 <no1@abc>\nÜbersetzer 2 <no2@abc>"
          a.website = "http://www.linuxadvanced.at/dokumentationen/la-ts.pdf"
           Gtk::AboutDialog.set_url_hook do |about,link|
	      `firefox #{a.website}`
	    end                                     
        a.website_label = _("Download: LA-TS-Documentation")
	 a.set_modal( true )
        a.run
        a.destroy

        #fenster3=About.new
	#fenster3.show   
	end


	def on_about_clicked

	 #Gtk::AboutDialog.set_url_hook do |about,link|
	  #    `iceweasel http://www.linuxadvanced.at/dokumentationen/la-ts.pdf`
	   # end
	    #Gtk::AboutDialog.set_email_hook do |about,link|
	     # `gnome-open mailto:#{link}`
	    #end
         a = AboutDialog.new

	 a.program_name=_("LA-Teaching-System")
          #a.artists = ["Rene Schwarzinger"]
          a.authors = ["Klaus Misof", "Rene Schwarzinger"]
          a.comments = "Lizenz: GPL2+"
          a.copyright = "Copyright (C) 2015-2016 Klaus Misof"
	  #a.documenters = ["Documenter 1 <no1@abc>", "Documenter 2 <no2@abc>"]
          a.license = "		Copyright (C) [2015]  [Klaus Misof]

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

On Debian GNU/Linux systems, the complete text of the GNU General
Public License can be found in `/usr/share/common-licenses/GPL'.
"
          a.logo = Gdk::Pixbuf.new( "#{$gb_working_dir}/icons/watch.png" )
          #a.name = "AboutDialog-Beispiel"
          #a.translator_credits = "Übersetzer 1 <no1@abc>\nÜbersetzer 2 <no2@abc>"
          a.version = "1.1-1"
          a.website = "http://www.linuxadvanced.at/dokumentationen/la-ts.pdf"
           Gtk::AboutDialog.set_url_hook do |about,link|
	      `firefox #{a.website}`
	    end                                     
          a.website_label = _("Download: LA-TS-Documentation")
	 a.set_modal( true )
        a.run
        a.destroy

        #fenster3=About.new
	#fenster3.show   
	end

	def on_save_clicked
        fs = FileSelection.new( _("Datei oeffnen") )
        fs.set_modal( self )
        fs.ok_button.signal_connect( "clicked" ) do
            #puts "gewaehlte Datei: #{ fs.filename }"
            #fs.destroy
        end
        fs.cancel_button.signal_connect( "clicked" ) do
            #fs.destroy
                                                                     
        end
        fs.run
        fs.destroy
	end

	def on_watch_clicked
        fenster1=ClientTable.new
	fenster1.show
	end

	def on_connect_info_clicked
        fenster1=Show_ip_password.new
	fenster1.show
	end

	def on_quit_clicked
        on_window_delete
	end
    
	def on_window_delete
        msg = _("Do you want to cleanup the students-list?") 
        #MessageDialog
        dialog = MessageDialog.new( nil, 0, 1, 4, msg )
        dialog.run do
            |response|
            if response == -8
		system("rm #{$gb_dir}/#{$gb_clientlist};touch #{$gb_dir}/#{$gb_clientlist}")
			system("sudo killall vncviewer")
			system("sudo killall x11vnc")
			system("killall ruby")
                dialog.destroy
                main_quit
                return false
                                                                     
            elsif response == -9
                dialog.destroy
		system("sudo killall vncviewer")
		system("sudo killall x11vnc")
               main_quit
                return false
            end
        end
        #MessageDialog Ende
        
	
    	end

    	def on_window_destroy
	main_quit
    	end

	self.add(@vbox)	
        self.show_all
     end
end

#init
#Latsmenue.new
#main

