#!/usr/bin/env ruby
 require 'gtk2'
require 'get_client_list'
require 'lock_control_cmd'
require '~/.laulc/conf/global'
 include Gtk

 class LockCheckbox < Window
	@eventbox
	@tab
	@listlength
	@chk
	@name
	@ip
	@vbox1
	@vbox2
	@vbox3
	@hbox1
	@radioopen
	@radioclose
	@frame
	@hbox
	@active
	
	
	def initialize
         	@chk=Array.new
		@active = Array.new
         	super
         	self.signal_connect( "destroy" ) do
            		on_window_destroy
        	end
         	
        	self.set_modal(true)
        	self.set_border_width( 3 )
	        self.set_window_position( Position::CENTER )
		clientlist=GetClientList.new("#{$gb_dir}/#{$gb_clientlist}")
		@name=clientlist.get_clientname
		@ip=clientlist.get_ipaddress
		@listlength=@name.length
	
        	@vbox1 = VBox.new( false, 30 )
        	# banner

		icon = Image.new("#{$gb_working_dir}/icons/la-banner-lock.png")
		@vbox1.add(icon)
		#Frame
        	@frame = Frame.new
        	@frame.set_label( "Students" )
        	@vbox2 = VBox.new( true, 0 )
        	
		#CheckButtons
		k=0
		@hbox2=HBox.new(false,3)
        	while k < @listlength do
        	       	 hbox = HBox.new( false, 0 )
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		hbox.pack_start( icon, false, false, 10 )
			label = Label.new( @name[k].to_s)
        		hbox.pack_start( label, false, false, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
        		@chk[k].set_active('true')
			@chk[k].add(hbox) 
			l=k%3	 
			if l!=0  then
				@hbox2.pack_start(@chk[k])
				@vbox2.pack_start(@hbox2)
			elsif				
				@hbox2=HBox.new(false,3)				
				@hbox2.pack_start(@chk[k])
				if k == @listlength-1 then
					@vbox2.pack_start(@hbox2)
					
				end

			end        		
		k += 1  
        	end
		
        	@btnremove = Button.new(Stock:: REMOVE)
        	@btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	@btnselect = Button.new(Stock::SELECT_ALL )
        	@btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	@hbox4 = HBox.new(false,10)
        	@hbox4.add(@btnselect)
        	 @hbox4.add(@btnremove)
		@hbox4.show
		@vbox2.add(@hbox4)
		

		@frame.add( @vbox2 )		
		
		#radiobox open close
		
        	@radioclose=RadioButton.new("LockScreen")
        	@radioopen=RadioButton.new(@radioclose,"UnLockScreen")
	
		@vbox3 = VBox.new( false, 0 )
        	
		@vbox3.add( @radioclose )
		@vbox3.add( @radioopen )
		

		@hbox1=HBox.new			
		@hbox1.add( @frame )
		@hbox1.add(@vbox3 )  
        	
		
		      	
		#@vbox1.pack_start( @frame )
		btnok = Button.new( Stock::OK )
        	btnok.signal_connect( "clicked" ) { on_btn_clicked }
        	btncancel = Button.new( Stock::CANCEL )
        	btncancel.signal_connect( "clicked" ) { on_cancel_clicked }
		label=Label.new("                    ")
		label.show
		@hbox=HBox.new(false,10)
		@hbox.add(label)		
		@hbox.add( btncancel )
        	@hbox.add(btnok)

        	@vbox1.pack_start( @hbox1,false,false, 10 )
        	@vbox1.pack_start( @hbox,false,false, 10 )
        	#vbox1.pack_start( btnok, false, false, 10 )

        	self.add( @vbox1 )
        	self.show_all
        end

	def on_select_clicked
		@frame.remove( @vbox2 )
		@vbox1.remove(@hbox)
		@hbox1.remove(@frame )
		@hbox1.remove( @vbox3 )       		
		self.remove(@vbox1)
       		#@vbox1 = VBox.new( false, 30 )
       		@frame = Frame.new
        	@frame.set_label( "Students" )
        	@vbox2 = VBox.new( true, 0 )
        	#CheckButtons
		k=0
		@chk=Array.new
        	while k < @listlength do
        	        hbox = HBox.new( false, 0 )
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		hbox.pack_start( icon, false, false, 10 )
			label = Label.new( @name[k].to_s)
        		hbox.pack_start( label, false, false, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
        		@chk[k].set_active('true')
			@chk[k].add(hbox)  
			l=k%3			
			if l!=0  then
				@hbox2.pack_start(@chk[k])
				@vbox2.pack_start(@hbox2)
			elsif				
				@hbox2=HBox.new(false,3)				
				@hbox2.pack_start(@chk[k])
				if k == @listlength-1 then
					@vbox2.pack_start(@hbox2)
				end

			end    		
		k += 1  
        	end
		
        	@frame.add( @vbox2 )
        	@hbox1.add(@frame)
		@hbox1.add( @vbox3)

		@btnremove = Button.new(Stock:: REMOVE)
        	@btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	@btnselect = Button.new(Stock::SELECT_ALL )
        	@btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	@hbox4 = HBox.new(false,10)
        	@hbox4.add(@btnselect)
        	 @hbox4.add(@btnremove)
		@hbox4.show
		@vbox2.add(@hbox4)
		
		
        	
        	#@vbox1.pack_start( @hbox1,false,false, 10 )
        	@vbox1.pack_start( @hbox,false,false, 10 )
        	self.add( @vbox1 )
        	self.show_all
        end
   
   def on_remove_clicked
		@frame.remove( @vbox2 )
		@vbox1.remove(@hbox)
		@hbox1.remove(@frame )
		@hbox1.remove( @vbox3 )       		
		self.remove(@vbox1)
       		#@vbox1 = VBox.new( false, 30 )
       		@frame = Frame.new
        	@frame.set_label( "Students" )
        	@vbox2 = VBox.new( true, 0 )
        	#CheckButtons
		k=0
		@chk=Array.new
        	while k < @listlength do
        	        hbox = HBox.new( false, 0 )
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		hbox.pack_start( icon, false, false, 10 )
			label = Label.new( @name[k].to_s)
        		hbox.pack_start( label, false, false, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
        		#@chk[k].set_active('true')
			@chk[k].add(hbox)  
			l=k%3			
			if l!=0  then
				@hbox2.pack_start(@chk[k])
				@vbox2.pack_start(@hbox2)
			elsif				
				@hbox2=HBox.new(false,3)				
				@hbox2.pack_start(@chk[k])
				if k == @listlength-1 then
					@vbox2.pack_start(@hbox2)
				end

			end    		
		k += 1  
        	end
		
        	@frame.add( @vbox2 )
        	@hbox1.add(@frame)
		@hbox1.add( @vbox3)

		@btnremove = Button.new(Stock:: REMOVE)
        	@btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	@btnselect = Button.new(Stock::SELECT_ALL )
        	@btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	@hbox4 = HBox.new(false,10)
        	@hbox4.add(@btnselect)
        	 @hbox4.add(@btnremove)
		@hbox4.show
		@vbox2.add(@hbox4)
		
		
        	
        	#@vbox1.pack_start( @hbox1,false,false, 10 )
        	@vbox1.pack_start( @hbox,false,false, 10 )
        	self.add( @vbox1 )
        	self.show_all
        end
   
   
   
   
	def on_btn_clicked
       		#Cmdfile erzeugen
       		file=File.new("#{$gb_dir}/#{$gb_webactual}",'w')
       		eigenschaften = 0
       		 msg = ""
               	k=0
		i=0
        	while k < @listlength do
               		if @chk[k].active? then 
				if @name[k] then        			
					file.#puts @name[k].to_s+","+@ip[k]
					@active[i]=@ip[k]
					i += 1
				end
        		end
        	   	k += 1
        		eigenschaften += 1 
        	end
        	file.close
		if @radioopen.active? then
			@active.each do
				|k|
				#puts "webopen:"+k
				unlockscreen(k)
    			end
		elsif 
			@active.each do
				|k|
				#puts "webclose:"+k
				lockscreen(k)
    			end
		end

        	self.destroy
        end
   
   	def on_cancel_clicked
		self.destroy
	end

       def on_window_destroy
        #main_quit	     
	end
	
end #Ende LockCheckbox


#init
#LockCheckbox.new
#main
