#!/usr/bin/env ruby
    require 'gtk2'
require 'client_entry' 
require 'client_data'
require 'client_table'
require '~/.laulc/conf/global'
 include Gtk

 class Fenster < Window

     def initialize
         super

         self.set_size_request( 400, 300 )
        self.set_title( "LA-SEMINAR" )
        self.signal_connect( "destroy" ) { main_quit }

        #VBox
        vbox = VBox.new( false, 0 )

        menubar = MenuBar.new
        vbox.pack_start( menubar, false, true, 0 )

        #Datei-Menue
        dateimenu_leiste = MenuItem.new( "_Datei", true )
        #Menuepunkt zur Menueleiste hinzufuegen
        menubar.append( dateimenu_leiste )

        dateimenu = Menu.new

        dateimenu_neu = MenuItem.new( "_neu", true )
        dateimenu_neu.set_name( "dateimenu_neu" )
        dateimenu_neu.signal_connect( "activate" ) do
            | widget |
            on_menu_activate( widget )
        end
        dateimenu.append( dateimenu_neu )

        dateimenu_speichern = MenuItem.new( "_speichern", true )
        dateimenu_speichern.set_name( "dateimenu_speichern" )
        dateimenu_speichern.signal_connect( "activate" ) do
            | widget |
            on_menu_activate( widget )
        end
        dateimenu.append( dateimenu_speichern )

        #Separator
        dateimenu.append( SeparatorMenuItem.new )

        dateimenu_ende = MenuItem.new( "be_enden", true )
        dateimenu_ende.set_name( "dateimenu_ende" )
        dateimenu_ende.signal_connect( "activate" ) do
            | widget |
            on_menu_activate( widget )
        end
        dateimenu.append( dateimenu_ende )
        dateimenu_leiste.set_submenu( dateimenu )

                                                                    
        #Hilfe-Menu
        hilfemenu_leiste = MenuItem.new( "_Hilfe", true )
        #Menuepunkt zur Menueleiste hinzufuegen
        menubar.append( hilfemenu_leiste )

        hilfemenu = Menu.new

        hilfemenu_info = MenuItem.new( "_info", true )
        hilfemenu_info.set_name( "hilfemenu_info" )
        hilfemenu_info.signal_connect( "activate" ) do
            | widget |
            on_menu_activate( widget )
        end
        hilfemenu.append( hilfemenu_info )
        hilfemenu_leiste.set_submenu( hilfemenu )

        self.add( vbox )
        self.show_all
    end

    def on_menu_activate( s )
        #puts s.name
	if s.name  == "dateimenu_speichern"
		fenster1=ClientEntry.new('jatitel','no','OK')
		fenster1.showfenster   
	end
	if s.name  == "dateimenu_neu"
		fenster2=ClientTable.new
		fenster2.show
	end	
	if s.name == "dateimenu_ende"
            main_quit
        end
    end

end

init
fenster=Fenster.new
fenster.show
main
