#!/usr/bin/env ruby
 require 'gtk2'
require 'get_client_list'
require 'web_control_cmd'
require 'remote_cmd'
require'xvnc_cmd_all'
require '~/.laulc/conf/global'
 include Gtk
require 'gettext'
include GetText
  bindtextdomain("vnc_checkbox", :path => '/usr/local/bin/km/liveusbcontrol/locale') 

 class VNCCheckbox < Window
	@eventbox
	@tab
	@listlength
	@chk
	@name
	@group
	@ip
	@vbox1
	@vbox2
	@vbox3
	@hbox1
	@radioopen
	@radioclose
	@frame
	@hbox
	@active
	
	
	def initialize
         	@chk=Array.new
		@active = Array.new
         	super
         	self.signal_connect( "destroy" ) do
            		on_window_destroy
        	end
         	self.set_title(_( "View/Access" ))
        	self.set_modal(true)
        	self.set_border_width( 3 )
	        self.set_window_position( Position::CENTER )
		self.set_resizable( false )
		clientlist=GetClientList.new("#{$gb_dir}/#{$gb_clientlist}")
		@name=clientlist.get_clientname
		@ip=clientlist.get_ipaddress
		@listlength=@name.length
		@group=clientlist.get_group
        	@vbox1 = VBox.new( false, 30 )
		
		#banner
        	icon = Image.new("#{$gb_working_dir}/icons/la-banner-remote.png")
		@vbox1.add(icon)
		
		#Frame
        	@frame = Frame.new
        	@frame.set_label( _("Students") )
        	@vbox2 = VBox.new( true, 3 )
        	
		#CheckButtons
		k=0
		@hbox2=HBox.new(false,3)
        	while k < @listlength do
        	       	
			@hbox = HBox.new( false, 0 )
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		@hbox.pack_start( icon, false, false, 10 )
			label = Label.new( @name[k].to_s)
        		@hbox.pack_start( label, false, false, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
        		@chk[k].set_active('true')
			@chk[k].add(@hbox)
			l=k%3	 
			if l!=0  then
				@hbox2.pack_start(@chk[k])
				@vbox2.pack_start(@hbox2)
			elsif				
				@hbox2=HBox.new(false,3)				
				@hbox2.pack_start(@chk[k])
				if k == @listlength-1 then
					@vbox2.pack_start(@hbox2)
				end
			end       		
		k += 1 
        	end
		while k< 4 do
				label=Label.new("")
				@vbox2.add(label)
				k +=1
		end 
        	@btnremove = Button.new(Stock:: REMOVE)
        	@btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	@btnselect = Button.new(Stock::SELECT_ALL )
        	@btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	@hbox4 = HBox.new(false,10)
        	@hbox4.add(@btnselect)
        	 @hbox4.add(@btnremove)
		@btngroupa = Button.new("A" )
        	@btngroupa.signal_connect( "clicked" ) { on_groupa_clicked }
		@btngroupb = Button.new("B" )
        	@btngroupb.signal_connect( "clicked" ) { on_groupb_clicked }		
		@hbox4.add(@btngroupa)
		@hbox4.add(@btngroupb)
		@hbox4.show
		@vbox2.pack_start(@hbox4)
		

		@frame.add( @vbox2 )		
		
		#radiobox open close
		
        	@radiosmall=RadioButton.new( _("Small (View)") )
		@radiomedium=RadioButton.new(@radiosmall,_("Medium (View)"))
        	@radiofull=RadioButton.new(@radiosmall,_("Full (View)"))
        	@radiomediumac=RadioButton.new(@radiosmall,_("Medium (Access)"))
        	@radiofullac=RadioButton.new(@radiosmall,_("Full (Access)"))
		@vbox3 = VBox.new( true, 0 )
        	
		
		@vbox3.add( @radiosmall )
		@vbox3.add( @radiomedium )
		@vbox3.add( @radiofull )
		
		@vbox3.add( @radiomediumac )
		@vbox3.add( @radiofullac )

		@hbox1=HBox.new			
		@hbox1.add( @frame )
		@hbox1.add(@vbox3 )  
        	
		
		      	
		#@vbox1.pack_start( @frame )
		btnok = Button.new( Stock::OK )
        	btnok.signal_connect( "clicked" ) { on_btn_clicked }
        	btncancel = Button.new( Stock::CANCEL )
        	btncancel.signal_connect( "clicked" ) { on_cancel_clicked }
		label=Label.new("                    ")
		label.show
		@hbox=HBox.new(false,10)
		@hbox.add(label)		
		@hbox.add( btncancel )
        	@hbox.add(btnok)

        	@vbox1.pack_start( @hbox1,false,false, 10 )
        	@vbox1.pack_start( @hbox,false,false, 10 )
        	#vbox1.pack_start( btnok, false, false, 10 )
        	
        	

        	self.add( @vbox1 )
        	self.show_all
        end

	def on_select1_clicked
		@frame.remove( @vbox2 )
		@vbox1.remove(@hbox1)
		@vbox1.remove(@hbox)
		@hbox1.remove(@frame )
		@hbox1.remove( @vbox3 )       		
		self.remove(@vbox1)
       		#@vbox1 = VBox.new( false, 30 )
       		@frame = Frame.new
        	@frame.set_label( _("Students") )
        	@vbox2 = VBox.new( true, 0 )
        	#CheckButtons
		k=0
		@chk=Array.new
        	while k < @listlength do
			hbox = HBox.new( false, 0 )
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		hbox.pack_start( icon, false, false, 10 )
			label = Label.new( @name[k].to_s)
        		hbox.pack_start( label, false, false, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
        		if @abutton=="A" then
				if @group[k].to_s.chomp=="group-A" then        		
				@chk[k].set_active('true')
				end			
			elsif @abutton=="B" then
				if @group[k].to_s.chomp=="group-B" then        		
				@chk[k].set_active('true')
				end
			elsif @abutton=="R" then
				#puts @abutton					
				#@chk[k].set_active('false')
			else	
				@chk[k].set_active('true')		
			end
			@chk[k].add(hbox)
			l=k%3	 
			if l!=0  then
				@hbox2.pack_start(@chk[k])
				@vbox2.pack_start(@hbox2)
			elsif				
				@hbox2=HBox.new(false,3)				
				@hbox2.pack_start(@chk[k])
				if k == @listlength-1 then
					@vbox2.pack_start(@hbox2)
				end
			end         		
		k += 1 
        	end
		while k< 4 do
				label=Label.new("")
				@vbox2.add(label)
				k +=1
		end 
        	@frame.add( @vbox2 )
        	@hbox1.add(@frame)
		@hbox1.add( @vbox3)

		@btnremove = Button.new(Stock:: REMOVE)
        	@btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	@btnselect = Button.new(Stock::SELECT_ALL )
        	@btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	@hbox4 = HBox.new(false,10)
        	@hbox4.add(@btnselect)
        	 @hbox4.add(@btnremove)
		@btngroupa = Button.new("A" )
        	@btngroupa.signal_connect( "clicked" ) { on_groupa_clicked }
		@btngroupb = Button.new("B" )
        	@btngroupb.signal_connect( "clicked" ) { on_groupb_clicked }		
		@hbox4.add(@btngroupa)
		@hbox4.add(@btngroupb)
		@hbox4.show
		@vbox2.add(@hbox4)
		
        	@vbox1.pack_start( @hbox1,false,false, 10 )
        	@vbox1.pack_start( @hbox,false,false, 10 )
        	
		

        	self.add( @vbox1 )
        	self.show_all
        end
   
     def on_groupa_clicked
		@abutton="A"
		on_select1_clicked
	end   
	
	 def on_groupb_clicked
		@abutton="B"
		on_select1_clicked
	end

        def on_remove_clicked
		@abutton="R"
		on_select1_clicked
        end
   
    def on_select_clicked
		@abutton="S"
		on_select1_clicked
        end
   
   
   
	def on_btn_clicked
       		#Cmdfile erzeugen
       		file=File.new("#{$gb_dir}/#{$gb_webactual}",'w')
       		eigenschaften = 0
       		 msg = ""
               	k=0
		i=0
        	while k < @listlength do
               		if @chk[k].active? then 
				#puts "yes"
				if @name[k] then        			
					file.#puts @name[k].to_s+","+@ip[k]
					@active[i]=@ip[k]
					i += 1
				end
        		end
        	   	k += 1
        	end
        	file.close
		z=50
		@trans=100
		if @radiosmall.active? then
			@active.each do
				|k|
				##puts "wbeopen:"+k 
				Thread.new{aquat(k,z)}
				z += @trans
    			end
		elsif @radiomedium.active?
			@active.each do
				|k|
				##puts "wbeclose:"+k
				Thread.new{ahalf(k,z)}
				z += @trans
    			end
		elsif @radiofull.active? then
			@active.each do
				|k|
				##puts "wbeopen:"+k
				Thread.new{afull(k,z)}
				z += @trans  			
			end
		
		elsif @radiomediumac.active?
			@active.each do
				|k|
				##puts "wbeclose:"+k
				Thread.new{ahalf_access(k,z)}
    				z += @trans
			end
		elsif @radiofullac.active? then
			@active.each do
				|k|
				##puts "wbeopen:"+k
				Thread.new{afull_access(k,z)}
				z += @trans     			
			end		
		end
		sleep($gb_sleep_vnc.to_i)
		

        	self.destroy
        end
   
   	def on_cancel_clicked
		self.destroy
	end
   

       def on_window_destroy
        #main_quit	     
	end
	
end #Ende VNCCheckbox


#init
#VNCCheckbox.new
#main
