#!/usr/bin/env ruby
 require 'gtk2'
require 'get_client_list'
require 'xvnc_cmd'
require '~/.laulc/conf/global'
 include Gtk

 class VncRadiobox < Window
	@eventbox
	@tab
	@listlength
	@chk
	@name
	@ip
	@vbox1
	@vbox2
	@frame
	@hbox
	
	
	def initialize
         	@chk=Array.new
         	super
         	self.signal_connect( "destroy" ) do
            		on_window_destroy
        	end
         	
        	self.set_modal(true)
        	self.set_border_width( 3 )
		clientlist=GetClientList.new("#{$gb_dir}/#{$gb_clientlist}")
		@name=clientlist.get_clientname
		@ip=clientlist.get_ipaddress
		@listlength=@name.length
	
        	@vbox1 = VBox.new( false, 30 )
        	#Frame
        	@frame = Frame.new
        	@frame.set_label( "WebStop" )
        	@vbox2 = VBox.new( true, 0 )
        	#CheckButtons
		k=0
		while k < @listlength do
        	       	if k == 0 then
        	       		@chk[k]=RadioButton.new(@name[k].to_s)
        		else
        			@chk[k]=RadioButton.new(@chk[0],@name[k].to_s)
        		end
        		@vbox2.pack_start(@chk[k])
        		k += 1 
        	end
        
        
        	@frame.add( @vbox2 )
        	@vbox1.pack_start( @frame )

        	btnok = Button.new( Stock::OK )
        	btnok.signal_connect( "clicked" ) { on_btn_clicked }
        	
        	
        	
        	
        	
        	@vbox1.pack_start( btnok, false, false, 10 )

        	self.add( @vbox1 )
        	self.show_all
        end


   
   
   
	def on_btn_clicked
       		k=0
        	Thread.start do
            	#loop do #Endlosschleife
        		while k < @listlength do
               			if @chk[k].active? then 
        				##puts @ip[k].to_s
        				half_access(@ip[k])
        			end
        			k += 1
        		end
        	end
        	self.destroy
        	#end   	
        end
   
   	

       def on_window_destroy
        #main_quit	     
	end
	
end #Ende CmdCheckbox


#init
#VncRadiobox.new
#main
