#!/usr/bin/env ruby
 $LOAD_PATH.unshift File.dirname($PROGRAM_NAME)
 ##puts "nun"
 ##puts $LOAD_PATH
 #$LOAD_PATH << ENV["/usr/local/bin/km/liveusbcontrol"]
 
require 'gtk2'
require 'client_entry' 
require 'show_ip_password'
require 'client_data'
require 'client_table'
require 'config_dialog'
require 'copy_checkbox'
require 'lock_checkbox'
require 'cmd_checkbox'
require 'web_checkbox'
require 'vnc_radiobox'
require 'file_selection'
require '~/.laulc/conf/global'
include Gtk


window = Gtk::Window.new(Gtk::Window::TOPLEVEL)
window.resizable = true
window.decorated = true
window.title = "LA Teaching System"
window.border_width = 10
window.signal_connect( "delete_event" ) { on_window_delete }
window.signal_connect( "destroy" ) { on_window_destroy }
#window.signal_connect('delete_event') { Gtk.main_quit }
window.set_size_request(720, -1)
window.set_resizable( false )


def item_cb(iid)
  #puts "Item ##{iid} selected."
end

# Create a toolbar with Cut, Copy, Paste and Select All
# toolbar items.
def create_toolbar(tb)
   	
  #icon = Image.new( "exmples/icons/camera.png" )
          
  #cut = Gtk::ToolButton.new(icon,'text')
  #icon = Image.new( "exmples/icons/camera1.png" )
  #cut.set_label('text')
  #cut.set_icon_widget(icon)
  #copy = Gtk::ToolButton.new(icon,'copy')

	icon = Image.new( "#{$gb_working_dir}/icons/watch.png" )
	watch = Gtk::ToolButton.new(icon,'Watch-Student-Clients')
	
	icon = Image.new( "#{$gb_working_dir}/icons/web.png" )
	webstop = Gtk::ToolButton.new(icon,'Lock/Unlock')

	icon = Image.new( "#{$gb_working_dir}/icons/system-lock-screen.png" )
	lock = Gtk::ToolButton.new(icon,'Students-Lock/Unlock')

	icon = Image.new( "#{$gb_working_dir}/icons/system-lock-screen.png" )
	exam = Gtk::ToolButton.new(icon,'Exam-Start')

	icon = Image.new( "#{$gb_working_dir}/icons/dialog-warning.png" )
	connect_info = Gtk::ToolButton.new(icon,'Connect-Info')
	
apply = Gtk::ToolButton.new(Gtk::Stock::APPLY)
preferences = Gtk::ToolButton.new(Gtk::Stock::PREFERENCES)
quit = Gtk::ToolButton.new(Gtk::Stock::STOP)
save= Gtk::ToolButton.new(Gtk::Stock::SAVE)
copy= Gtk::ToolButton.new(Gtk::Stock::COPY)
connect= Gtk::ToolButton.new(Gtk::Stock::CONNECT)
about= Gtk::ToolButton.new(Gtk::Stock::ABOUT)
help = Gtk::ToolButton.new(Gtk::Stock::HELP)
info=Gtk::ToolButton.new(Gtk::Stock::INFO)
#info.signal_connect('activate'){p "Embedded: #{si.embedded?}"; p "Visible: #{si.visible?}"; p "Blinking: #{si.blinking?}"}
quit=Gtk::ToolButton.new(Gtk::Stock::QUIT)

  #toggle = Gtk::ToggleToolButton.new(Gtk::Stock::HOME)
  #toggle.active = true

 
  #separator.draw = false
  #separator.expand = false

  tb.show_arrow = true
  tb.toolbar_style = Gtk::Toolbar::Style::BOTH

  # NOTE: tool-tips are only part of the deprecated interface ?!
  tb.insert(0, watch)
  tb.insert(1, connect_info)
  #tb.insert(2, lock)
  tb.insert(2, webstop)
  #tb.insert(3, Gtk::SeparatorMenuItem.new)
  tb.insert(3, preferences)
  #tb.insert(5, help)
  tb.insert(4, copy)
  tb.insert(5, exam)
  #tb.insert(8, Gtk::SeparatorMenuItem.new)
  tb.insert(6, quit)
  #tb.insert(8, quit)
  
save.signal_connect('clicked')       { on_save_clicked }
watch.signal_connect('clicked')       { on_watch_clicked }
connect_info.signal_connect('clicked')       { on_connect_info_clicked }
exam.signal_connect('clicked')       { on_exam_clicked }
apply.signal_connect('clicked')       { on_apply_clicked }
preferences.signal_connect('clicked')  { on_preferences_clicked }
connect.signal_connect('clicked')       { on_connect_clicked }
about.signal_connect('clicked')       { on_about_clicked }
help.signal_connect('clicked')       { on_help_clicked }
quit.signal_connect('clicked')       { on_quit_clicked }
webstop.signal_connect('clicked')       { on_webstop_clicked }
lock.signal_connect('clicked')       { on_lock_clicked }
copy.signal_connect('clicked')       { on_copy_clicked }
end

def on_preferences_clicked
	#        fenster1=
	ConfigDialog.new
	#fenster1.show   
end

def on_lock_clicked
        fenster1=LockCheckbox.new
	fenster1.show   
end

def on_copy_clicked
        fenster1=CopyCheckbox.new
	fenster1.show   
end

def on_webstop_clicked
        fenster1=WebCheckbox.new
	fenster1.show   
end

def on_connect_clicked
        fenster1=VncRadiobox.new
	fenster1.show   
end

def on_connect_info_clicked
        fenster1=Show_ip_password.new
	fenster1.show
end
def on_exam_clicked
        fenster1=CmdCheckbox.new
	fenster1.show   
end

def on_apply_clicked
        fenster1=CmdCheckbox.new
	fenster1.show   
end

def on_help_clicked
        fenster1=Window.new("Help")
	fenster1.set_border_width( 30 )
	#fenster1.set_window_position(Position::CENTER)
	label=Label.new("Es gibt noch keine Hilfe!!")	
	fenster1.add(label)
	fenster1.show_all  
end

def on_about_clicked
         a = AboutDialog.new
          #a.artists = ["Grafiker 1 <no1@abc>", "Grafiker 2 <no2@abc>"]
          #a.authors = ["Klaus Misof <klausmisof@gmx.at>", ""]
          a.comments = "Lizenz: GPL2"
          a.copyright = "Copyright (C) 2010-2011 Klaus Misof"
          #a.documenters = ["Documenter 1 <no1@abc>", "Documenter 2 <no2@abc>"]
          #a.license = "Lizenz: GPL2"
          a.logo = Gdk::Pixbuf.new( "#{$gb_working_dir}/icons/LA.png" )
          a.name = "AboutDialog-Beispiel"
          #a.translator_credits = "Übersetzer 1 <no1@abc>\nÜbersetzer 2 <no2@abc>"
          a.version = "0.1-Beta"
          #a.website = "http://www.linuxadvanced.abc"
                                                
        #a.website_label = "Titel der Webseite"
	 a.set_modal( true )
        a.run
        a.destroy

        #fenster3=About.new
	#fenster3.show   
end

def on_save_clicked
        fs = FileSelection.new( "Datei oeffnen" )
        fs.set_modal( self )
        fs.ok_button.signal_connect( "clicked" ) do
            #puts "gewählte Datei: #{ fs.filename }"
            #fs.destroy
        end
        fs.cancel_button.signal_connect( "clicked" ) do
            #fs.destroy
                                                                     
        end
        fs.run
        fs.destroy
end

def on_watch_clicked
        fenster1=ClientTable.new
	fenster1.show
end

def on_quit_clicked
        on_window_delete
end
    
def on_window_delete
        msg = "Do you really want to quit the program?"
        #MessageDialog
        dialog = MessageDialog.new( nil, 0, 1, 5, msg )
        dialog.run do
            |response|
            if response == -5
                dialog.destroy
                main_quit
                return false
                                                                     
            elsif response == -6
                dialog.destroy
               
                return true
            end
        end
        #MessageDialog Ende
        
    end

    def on_window_destroy
        main_quit
    end



toolbar = Gtk::Toolbar.new
create_toolbar(toolbar)

vbox = Gtk::VBox.new(false, 5)
vbox.pack_start_defaults(toolbar)
#vbox.pack_start_defaults(entry)

window.add(vbox)
window.show_all
Gtk.main

