#!/usr/bin/env ruby
$LOAD_PATH.unshift File.dirname($PROGRAM_NAME)
require 'gtk2'
require 'get_client_list'
require 'web_control_cmd'
require '~/.laulc/conf/global'
 include Gtk

 class WebCheckbox < Window
	@eventbox
	@tab
	@listlength
	@chk
	@name
	@ip
	@vbox1
	@vbox2
	@vbox3
	@hbox1
	@radioopen
	@radioclose
	@frame
	@hbox
	@active
	
	
	def initialize
         	@chk=Array.new
		@active = Array.new
         	super
         	self.signal_connect( "destroy" ) do
            		on_window_destroy
        	end
         	
        	self.set_modal(true)
        	self.set_border_width( 3 )
	        self.set_window_position( Position::CENTER )
		clientlist=GetClientList.new("#{$gb_dir}/#{$gb_clientlist}")
		@name=clientlist.get_clientname
		@ip=clientlist.get_ipaddress
		@listlength=@name.length
	
        	@vbox1 = VBox.new( false, 30 )
		
		#banner
        	icon = Image.new("#{$gb_working_dir}/icons/la-banner.png")
		@vbox1.add(icon)
		
		#Frame
        	@frame = Frame.new
        	@frame.set_label( "Clients" )
        	@vbox2 = VBox.new( true, 3 )
        	
		#CheckButtons
 		@tab = Table.new(@listlength /2, 2, true )
        	@tab.set_column_spacings( 3 )
        	@tab.set_row_spacings( 3 )
		i=0
        	j=0
		k=0
        	while k < @listlength do
			while j< 2 && k < @listlength do
        	       	hbox = HBox.new( false, 0 )
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		hbox.pack_start( icon, false, false, 10 )
			label = Label.new( @name[k].to_s)
        		hbox.pack_start( label, false, false, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
        		@chk[k].set_active('true')
			@chk[k].add(hbox)  


			@tab.attach( @chk[k], j, j + 1, i, i + 1 )

			      		
			#@vbox2.pack_start(@chk[k])
			j +=1
                	k += 1
        		end
		i +=1 
        	end

        	@btnremove = Button.new(Stock:: REMOVE)
        	@btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	@btnselect = Button.new(Stock::SELECT_ALL )
        	@btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	@hbox4 = HBox.new(false,10)
        	@hbox4.add(@btnselect)
        	 @hbox4.add(@btnremove)
		@hbox4.show
		@vbox2.add(@hbox4)
		

		@frame.add( @tab )		
		
		#radiobox open close
		@radiowebopen=RadioButton.new("WebOpen")
        	@radiowebclose=RadioButton.new(@radiowebopen,"WebClose")
		@radiolockclose=RadioButton.new(@radiowebopen,"LockScreen")
        	@radiolockopen=RadioButton.new(@radiowebopen,"UnLockScreen")
        		
		@vbox3 = VBox.new( true, 0 )
        	@vbox3.add( @radiowebopen )
		@vbox3.add( @radiowebclose )
		@vbox3.add( @radiolockopen )
		@vbox3.add( @radiolockclose )
		

		@hbox1=HBox.new			
		@hbox1.add( @frame )
		@hbox1.add(@vbox3 )  
        	
		
		      	
		#@vbox1.pack_start( @frame )
		btnok = Button.new( Stock::OK )
        	btnok.signal_connect( "clicked" ) { on_btn_clicked }
        	btncancel = Button.new( Stock::CANCEL )
        	btncancel.signal_connect( "clicked" ) { on_cancel_clicked }
		label=Label.new("                    ")
		label.show
		@hbox=HBox.new(false,10)
		@hbox.add(label)		
		@hbox.add( btncancel )
        	@hbox.add(btnok)

        	@vbox1.pack_start( @hbox1,false,false, 10 )
        	@vbox1.pack_start( @hbox,false,false, 10 )
        	#vbox1.pack_start( btnok, false, false, 10 )
        	
        	

        	self.add( @vbox1 )
        	self.show_all
        end

	def on_select_clicked
		@frame.remove( @vbox2 )
		@vbox1.remove(@hbox1)
		@vbox1.remove(@hbox)
		@hbox1.remove(@frame )
		@hbox1.remove( @vbox3 )       		
		self.remove(@vbox1)
       		#@vbox1 = VBox.new( false, 30 )
       		@frame = Frame.new
        	@frame.set_label( "Clients" )
        	@vbox2 = VBox.new( true, 0 )
        	#CheckButtons
		k=0
		@chk=Array.new
        	while k < @listlength do
			hbox = HBox.new( false, 0 )
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		hbox.pack_start( icon, false, false, 10 )
			label = Label.new( @name[k].to_s)
        		hbox.pack_start( label, false, false, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
        		@chk[k].set_active('true')
			@chk[k].add(hbox)        		
			@vbox2.pack_start(@chk[k])
        		k += 1 
        	end
        	@frame.add( @vbox2 )
        	@hbox1.add(@frame)
		@hbox1.add( @vbox3)

		@btnremove = Button.new(Stock:: REMOVE)
        	@btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	@btnselect = Button.new(Stock::SELECT_ALL )
        	@btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	@hbox4 = HBox.new(false,10)
        	@hbox4.add(@btnselect)
        	 @hbox4.add(@btnremove)
		@hbox4.show
		@vbox2.add(@hbox4)
		
        	@vbox1.pack_start( @hbox1,false,false, 10 )
        	@vbox1.pack_start( @hbox,false,false, 10 )
        	
		

        	self.add( @vbox1 )
        	self.show_all
        end
   
   def on_remove_clicked
		@frame.remove( @vbox2 )
		@vbox1.remove(@hbox1)
		@vbox1.remove(@hbox)
		@hbox1.remove(@frame )
		@hbox1.remove( @vbox3 )       		
		self.remove(@vbox1)
       		#@vbox1 = VBox.new( false, 30 )
       		@frame = Frame.new
        	@frame.set_label( "Clients" )
        	@vbox2 = VBox.new( true, 0 )
        	#CheckButtons
		k=0
		@chk=Array.new
        	while k < @listlength do
			hbox = HBox.new( false, 0 )
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		hbox.pack_start( icon, false, false, 10 )
			label = Label.new( @name[k].to_s)
        		hbox.pack_start( label, false, false, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
        		#@chk[k].set_active('true')
			@chk[k].add(hbox)        		
			@vbox2.pack_start(@chk[k])
        		k += 1 
        	end
        	@frame.add( @vbox2 )
        	@hbox1.add(@frame)
		@hbox1.add( @vbox3)

		@btnremove = Button.new(Stock:: REMOVE)
        	@btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	@btnselect = Button.new(Stock::SELECT_ALL )
        	@btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	@hbox4 = HBox.new(false,10)
        	@hbox4.add(@btnselect)
        	 @hbox4.add(@btnremove)
		@hbox4.show
		@vbox2.add(@hbox4)
		

		#@frame.add( @vbox2 )
		#@vbox1.pack_start( @frame )
		#@vbox1.pack_start( @hbox1 )
        	        	
        	#btnok = Button.new( Stock::OK )
        	#btnok.signal_connect( "clicked" ) { on_btn_clicked }
        	#btnremove = Button.new(Stock:: REMOVE)
        	#btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	#btnselect = Button.new(Stock::SELECT_ALL )
        	#btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	#@hbox = HBox.new
        	#@hbox.add(btnselect)
        	#@hbox.add(btnremove)
        	#@hbox.add(btnok)

        	@vbox1.pack_start( @hbox1,false,false, 10 )
        	@vbox1.pack_start( @hbox,false,false, 10 )
        	
		#vbox1.pack_start( btnok, false, false, 10 )

        	self.add( @vbox1 )
        	self.show_all
        end
   
   
   
   
	def on_btn_clicked
       		#Cmdfile erzeugen
       		file=File.new("#{$gb_dir}/#{$gb_webactual}",'w')
       		eigenschaften = 0
       		 msg = ""
               	k=0
		i=0
        	while k < @listlength do
               		if @chk[k].active? then 
				#puts "yes"
				if @name[k] then        			
					file.#puts @name[k].to_s+","+@ip[k]
					@active[i]=@ip[k]
					i += 1
				end
        		end
        	   	k += 1
        	end
        	file.close
		if @radiowebopen.active? then
			@active.each do
				|k|
				##puts "wbeopen:"+k
				Thread.new {webopen(k)}
    			end
		elsif @radiowebclose.active?
			@active.each do
				|k|
				##puts "wbeclose:"+k
				Thread.new{webclose(k)}
    			end
		elsif @radiolockopen.active? then
			@active.each do
				|k|
				##puts "wbeopen:"+k
				Thread.new {unlockscreen(k)}
    			end
		elsif 
			@active.each do
				|k|
				##puts "wbeclose:"+k
				Thread.new {lockscreen(k)}
    			end		
		end

        	self.destroy
        end
   
   	def on_cancel_clicked
		self.destroy
	end
   

       def on_window_destroy
        #main_quit	     
	end
	
end #Ende CmdCheckbox


init
WebCheckbox.new
main
