#!/usr/bin/env ruby
## coding: utf-8
  $LOAD_PATH.unshift File.dirname($PROGRAM_NAME)
require '~/.laulc/conf/global.rb'
require 'gtk2'
 require 'ip_get_cmd'
require 'client_data'
require 'create_laulc_user'
require 'teaching_stop_cmd'
require 'delete_in_out'
require 'get_in_out_parameter'
 include Gtk

 class ClientEntry < Window

     #Membervariablen
     
     

    def initialize
        super
	self.title = "Add-Student-Client"
        
        self.signal_connect( "destroy" ) do
            on_window_destroy
        end

       def on_window_destroy
        #main_quit	     
	end

        #@w.set_size_request( 320, 160 )
        #@w.resizable = false
	self.set_border_width( 10 )
        self.set_window_position( Position::CENTER )
        self.set_resizable( false )


	@ip_self = get_self_ip.chomp
	@mac_self = get_self_mac(@ip_self).chomp
	@mask_self = get_self_mask.chomp
	

	# banner-icon
	icon = Image.new("#{$gb_working_dir}/icons/la-ts-client.png")
	


	#get teacher-network
	@iplist = @ip_self.split(".")
	
	@masklist= @mask_self.split(".")

	if @masklist[0] != "0" && @masklist[1] != "0" && @masklist[2] != "0"  && @masklist[3] == "0" then	
		@teacher_ip=@iplist[0]+"."+@iplist[1]+"."+@iplist[2]+".xxx"
	elsif @masklist[0] != "0" && @masklist[1] != "0" && @masklist[2] == "0"  && @masklist[2] == "0"  
		@teacher_ip=@iplist[0]+"."+@iplist[1]+".xxx.yyy"
	elsif @masklist[0] != "0" && @masklist[1] == "0" && @masklist[2] == "0"  && @masklist[2] == "0"
		@teacher_ip=@iplist[0]+".xxx.yyy.zzz"
	elsif @masklist[0] == "0" && @masklist[1] == "0" && @masklist[2] == "0"  && @masklist[2] == "0"
		@teacher_ip="nnn.xxx.yyy.zzz"	
	end	
	
	
	#puts @ip_self	
        @hbox1 = HBox.new(false,10)
	@label1=Label.new("Teacher-IP:")
	@hbox1.add(@label1)
	@entry1 = Entry.new
        #@entry1.set_size_request( 160, 20 )
        @entry1.set_text( @teacher_ip)
	@hbox1.add(@entry1)

	 @hbox5 = HBox.new(false,10)
	@label5=Label.new("PIN-Code:    ")
	@hbox5.add(@label5)
	@entry5 = Entry.new
        #@entry1.set_size_request( 160, 20 )
        #@entry5.set_text( @teacher_ip)
	@hbox5.add(@entry5)

	@hbox2 = HBox.new(false,10)
	@label2=Label.new("Name:         ")
	@hbox2.add(@label2)
	@entry2 = Entry.new
        #@entry2.set_size_request( 160, 20 )
        @entry2.set_text("name")
	@hbox2.add(@entry2)
	
	
	
	@vbox1=VBox.new(false,10)
	@vbox1.add(icon)	
	@vbox1.add( @hbox1)
	@vbox1.add( @hbox2)
	@vbox1.add(@hbox5)
	
			

	@btnok = Button.new( Stock::OK)
	@btnok_handler_id=@btnok.signal_connect( "clicked" ) do
            on_btnok_clicked
         end
	if @entry1.text == "" then	
	@btnok.signal_handler_block( @btnok_handler_id ) 
	@btnok.set_label( "No Network!!" )
	end		
	
        @btncancel = Button.new(Stock::CANCEL)
        @btncancel.signal_connect( "clicked" ) do
            on_cancel_clicked
         end

	@btnreset = Button.new(Stock::REVERT_TO_SAVED)
        @btnreset.signal_connect( "clicked" ) do
            on_reset_clicked
         end
         
         label=Label.new("")
         hbox=HBox.new(false,10)
         hbox.add(label)
	 hbox.add(@btnreset)
         hbox.add(@btncancel)
         hbox.add(@btnok)
         @vbox1.add(hbox)

	self.add(@vbox1)
	self.set_title( "Version: #{$gb_version}" )        
	self.set_modal(true)
	self.set_decorated(true)
	self.resizable = false
	#self.set_has_frame(false)
        self.show_all
        
    end

    
    def on_btnok_clicked
	self.window.set_cursor(Gdk::Cursor.new(Gdk::Cursor::WATCH))
	@clientname1=@entry2.text.chomp
	@clientname2=@clientname1.capitalize
	@clientname1=@clientname2.sub(/ü/,"ue")
	@clientname2=@clientname1.sub(/ä/,"ae")
	@clientname1=@clientname2.sub(/ö/,"oe")
	@clientname2=@clientname1.sub(/ß/,"ss")
	@clientname1=@clientname2.sub(/Ä/,"Ae")
	@clientname2=@clientname1.sub(/Ü/,"Ue")
	@clientname=@clientname2.sub(/Ö/,"Oe")
	@clientname=@clientname.sub(/\s/,"-")
	@entry2.text=@clientname
	#system("sudo echo y | sudo ufw reset")
#puts "sshpass -p #{@entry5.text}  ssh -l #{$gb_live_user} #{@entry1.text}  -o ConnectTimeout=2 'sudo #{$gb_working_dir}/client_remote_add.rb #{$gb_clientlist},client1,#{@entry2.text},#{@mac_self},#{@ip_self},on'"	
	rueckgabe=system("sshpass -p #{@entry5.text}  ssh -l #{$gb_live_user} -o ConnectTimeout=2 #{@entry1.text}  'exit'")	
	if rueckgabe==false then
		msg = "Connection failed! \n with:  \n IP: #{@entry1.text} \n Name: #{@entry2.text} \n PIN-Code: #{@entry5.text} "
		#system("sudo hostname #{@entry2.text}")
		dialog = MessageDialog.new( self, 0, 2, 2, msg)
		dialog.run
		dialog.destroy
		exit
	end	
	rueckgabe=`sshpass -p #{@entry5.text}  ssh -l #{$gb_live_user} #{@entry1.text} sudo #{$gb_working_dir}/get_version.rb`	
	rueckgabe=rueckgabe.chomp.delete("'")
	version=$gb_version.chomp.delete("'")
	#puts "***************************"	
	#puts rueckgabe
	#puts version	
	if rueckgabe != $gb_version.chomp.delete("'") then
		msg = "Your LATS-Version (#{version}) differs from theVersion of your teacher (#{rueckgabe})!! \n Please upgrade your LATS-Version  from \n sudo apt-get update;sudo apt-get install lateaching!"
		#system("sudo hostname #{@entry2.text}")
		dialog = MessageDialog.new( self, 0, 2, 2, msg)
		dialog.run
		dialog.destroy
		exit
	end
	
	

	rueckgabe=`sshpass -p #{@entry5.text}  ssh -l #{$gb_live_user} #{@entry1.text}  'sudo #{$gb_working_dir}/client_remote_add.rb #{$gb_clientlist},client1,#{@entry2.text},#{@mac_self},#{@ip_self},on'`	
	#puts "sudo #{$gb_working_dir}/client_remote_add.rb #{$gb_clientlist},client1,#{@entry2.text},#{@mac_self},#{@ip_self},on"	
	puts rueckgabe
	rueckgabe=rueckgabe.chomp
	if rueckgabe == "name_conflict" then
		#puts "WRONG"		
		msg = "The clients name is already used! Use a different client-name!"
		dialog = MessageDialog.new( self, 0, 2, 2, msg)
		dialog.run
		dialog.destroy
		exit
	end
	if rueckgabe == "ip_conflict" then
		#puts "IPIPIP"	
		msg = "Your IP adress is already used!"
		dialog = MessageDialog.new( self, 0, 2, 2, msg)
		dialog.run
		dialog.destroy
		exit
	end
	if rueckgabe !="" then
		#puts "LEEEEEEEER"
		passwordwith="'"+@entry5.text+"'".chomp
		test=`sed -i '/$gb_live_passwd=/c $gb_live_passwd="#{passwordwith}"' ~/.laulc/conf/global.rb`	
		puts "IJIJIJIJIJIJi"		
		puts test		
		$gb_live_passwd=@entry5.text
		password=`sshpass -p #{$gb_live_passwd}  ssh -l #{$gb_live_user} #{@entry1.text}  'sudo #{$gb_working_dir}/get_password.rb'`	
		password=password.chomp
		root_password=`sshpass -p #{$gb_live_passwd}  ssh -l #{$gb_live_user} #{@entry1.text}  'sudo #{$gb_working_dir}/get_root_password.rb'`	
		root_password=root_password.chomp
		laulc_user=`sshpass -p #{$gb_live_passwd}  ssh -l #{$gb_live_user} #{@entry1.text}  'sudo #{$gb_working_dir}/get_laulc_user.rb'`	
		laulc_user=laulc_user.chomp
		boxname=@entry2.text.chomp
		in_out=`sshpass -p #{$gb_live_passwd}  ssh -l #{$gb_live_user} #{@entry1.text}  'sudo #{$gb_working_dir}/get_in_out_parameter.rb'`	
		in_out=in_out.chomp
		test_p=password.empty?	
		test_l=laulc_user.empty?
		test_b=boxname.empty?
		if test_p!="true" then
			if test_l!="true" then
				if test_p!="true" then
					create_laulc_user(password,laulc_user,boxname)
					teaching_stop
				end
			end
		elsif
			msg = "Add-Client failed! Onknown error! \n Restart the teachers workstation!"
			dialog = MessageDialog.new( self, 0, 2, 2, msg )
			dialog.run
			dialog.destroy
			self.destroy		
			main_quit	
		end
		if in_out =="yes" then
			delete_in_out
		end		
		
		msg = "Add-Client succeed!"
		dialog = MessageDialog.new( self, 0, 2, 2, msg)
		dialog.run
		dialog.destroy
        
	elsif rueckgabe=="name_conflict" then 
		msg = "Add-Client failed! Name-Conflict"
		dialog = MessageDialog.new( self, 0, 2, 2, msg )
		dialog.run
		dialog.destroy
		self.destroy		
		main_quit
	elsif	rueckgabe=="ip_conflict" then 
		msg = "Add-Client failed! IP-Conflict"
		dialog = MessageDialog.new( self, 0, 2, 2, msg )
		dialog.run
		dialog.destroy
		self.destroy		
		main_quit
	end
	
	
	self.destroy
	main_quit
	
    end

    def on_cancel_clicked
	 self.destroy      
    end

    def on_reset_clicked
	puts "***********************************"        
	msg = "Do you want to reset to original configuration?" 
        #MessageDialog
        dialog = MessageDialog.new( nil, 0, 1, 4, msg )
        dialog.run do
            |response|
            if response == -8
	
		system("cp /usr/local/bin/km/liveusbcontrol/global/global.rb ~/.laulc/conf/global.rb")
		system("sudo rm /etc/ssh/ssh_host_*")
		system(" sudo ssh-keygen -A")		
		dialog.destroy
                #main_quit
                return false
                                                                     
            elsif response == -9
                dialog.destroy
               #main_quit
                return false
            end
    	end
        #MessageDialog Ende
    end




end

init
ClientEntry.new
main
