#!/usr/bin/env ruby
$LOAD_PATH.unshift File.dirname($PROGRAM_NAME) 
require 'gtk2'
require 'get_client_list'
require 'copy_cmd'
require 'group_control_cmd'
require 'get_global_list'
require '~/.laulc/conf/global'
require 'known_hosts_del'
 include Gtk
require 'gettext'
include GetText
 bindtextdomain("copy_checkbox", :path => '/usr/local/bin/km/liveusbcontrol/locale') 

 class CopyCheckbox < Window
	@pb	
	@entry
	@btnremove
	@btnselect
	@tab
	@listlength
	@chk
	@name
	@group
	@ip
	@vbox1
	@vbox2
	@vbox3
	@vbox4
	@hbox1
	@hbox4
	@hbox2
	@radioput
	@radioget
	@frame1
	@frame2
	@frame3
	@hbox
	@active
	@active_name
	
	
	def initialize
		
		@dir_home=`echo ~`
		@dir_home=@dir_home.chomp
		@entry = Array.new         	
		@chk = Array.new
		@active = Array.new
		@active_name = Array.new         	
		super
         	self.signal_connect( "destroy" ) do
            		on_window_destroy
        	end
         	self.set_title(_( "Copy" ))
        	self.set_modal(true)
        	self.set_border_width( 3 )
	        self.set_window_position( Position::CENTER )
		self.set_resizable( false )
		clientlist=GetClientList.new("#{$gb_dir}/#{$gb_clientlist}")
		@name=clientlist.get_clientname
		@ip=clientlist.get_ipaddress
		@listlength=@name.length
		@group=clientlist.get_group

		#get_global_list
		@filename="#{$gb_dir}/conf/global.rb"
		file=GetGlobalList.new(@filename)
		@global=file.get_globalcontent
        	
		@vbox1 = VBox.new( false, 10 )
        	#banner
		icon = Image.new("#{$gb_working_dir}/icons/la-banner-copy.png")
		@vbox1.add(icon)
		#Frame
        	@frame1 = Frame.new
        	@frame1.set_label( _("Students") )
        	@vbox2 = VBox.new( false, 0)
        	
		#CheckButtons
		k=0
		@hbox2=HBox.new(false,3)
        	while k < @listlength do
        	        hbox = HBox.new( false, 0 )
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		hbox.pack_start( icon, false, false, 10 )
			label = Label.new(@name[k][0..$gb_namelength.to_i].rjust($gb_namelength.to_i))
			label.set_width_chars($gb_namelength.to_i+2)
        		hbox.pack_start( label, false, false, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
        		@chk[k].set_active('true')
			@chk[k].add(hbox)        		
			l=k%3			
			if l != 0   then
				@hbox2.pack_start(@chk[k])
				@vbox2.pack_start(@hbox2)
			elsif				
				@hbox2=HBox.new(false,3)				
				@hbox2.pack_start(@chk[k])
				if k == @listlength-1 then
					@vbox2.pack_start(@hbox2)
				end
			end
        		k += 1
			  
        	end
		while k< 10 do
				label=Label.new("")
				@vbox2.add(label)
				k +=1
		end 
        
		@btnremove = Button.new(Stock:: REMOVE)
        	@btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	@btnselect = Button.new(Stock::SELECT_ALL )
        	@btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	@hbox4 = HBox.new(false,10)
        	@hbox4.add(@btnselect)
        	 @hbox4.add(@btnremove)
		@btngroupa = Button.new("A" )
        	@btngroupa.signal_connect( "clicked" ) { on_groupa_clicked }
		@btngroupb = Button.new("B" )
        	@btngroupb.signal_connect( "clicked" ) { on_groupb_clicked }		
		@hbox4.add(@btngroupa)
		@hbox4.add(@btngroupb)
		@hbox4.show
		@vbox2.add(@hbox4)
		@frame1.add( @vbox2 )
			
		
		@vbox3 = VBox.new( true, 0 )
        	
		
		
		@frame2 = Frame.new
        	@frame2.set_label( "Directories" )

		#teacherdirs
		@entry[0]= FileChooserButton.new(_("Application"), FileChooser::ACTION_SELECT_FOLDER)
		test=@global['$gb_teacher_out'].slice(/~/)
		if test == "~" then  
						
			@global['$gb_teacher_out']=@global['$gb_teacher_out'].sub("~","#{@dir_home}")
		end		

	@entry[0].current_folder = "#{@global['$gb_teacher_out'].chomp}"
		tooltips = Tooltips.new
        	tooltips.set_tip( @entry[0],_("All data of this directory\n will be copied to the students"),"")         	
		@entry[0].show
        	hbox3 = HBox.new	
        	label = Label.new(_("Teacher-Out-Directory:"))
        	label.show
        	hbox3.add(label)
        	hbox3.add(@entry[0])
        	hbox3.show
		@vbox3.add( hbox3 )
		
		@entry[1] = FileChooserButton.new(_("Application"), FileChooser::ACTION_SELECT_FOLDER)
		test=@global['$gb_teacher_in'].slice(/~/)
		if test == "~" then  
						
			@global['$gb_teacher_in']=@global['$gb_teacher_in'].sub("~","#{@dir_home}")
		end		
		@entry[1].current_folder = "#{@global['$gb_teacher_in'].chomp}"
		tooltips = Tooltips.new
        	tooltips.set_tip( @entry[1],_("All data of the students out directory \n will be copied to this directory\n For reach student a folder will be created"),"")         	
		@entry[1].show
        	hbox3 = HBox.new
        	label = Label.new(_("Teacher-In-Directory   :"))
        	label.show
        	hbox3.add(label)
        	hbox3.add(@entry[1])
        	hbox3.show
		@vbox3.add( hbox3 )

		@entry[2] = Entry.new
		@entry[2].text = "#{@global['$gb_student_out'].chomp}"
		tooltips = Tooltips.new
        	tooltips.set_tip( @entry[2],_("All data from this directory \n will be copied to the teacher 's in directory"),"")         	
		@entry[2].show
        	hbox3 = HBox.new
        	label = Label.new(_("Student-Out-Directory  :"))
        	label.show
        	hbox3.add(label)
        	hbox3.add(@entry[2])
        	hbox3.show
		@vbox3.add( hbox3 )

		@entry[3] = Entry.new
		@entry[3].text = "#{@global['$gb_student_in'].chomp}"
		tooltips = Tooltips.new
        	tooltips.set_tip( @entry[3],_("This directory is used to get the data\n from the teacher's out directory."),"")         	

        	@entry[3].show
        	hbox3 = HBox.new
        	label = Label.new("Student-In-Directory     :")
        	label.show
        	hbox3.add(label)
        	hbox3.add(@entry[3])
        	hbox3.show
		@vbox3.add( hbox3 )

		@entry[4] = Entry.new
		@entry[4].text = "#{@global['$gb_student_in_filter'].chomp}"
		tooltips = Tooltips.new
        	tooltips.set_tip( @entry[4],_("Use * for all data"),"")        	
		@entry[4].show
        	hbox3 = HBox.new
        	label = Label.new(_("Student-In-Filter            :"))
        	label.show
        	hbox3.add(label)
        	hbox3.add(@entry[4])
        	hbox3.show
		@vbox3.add( hbox3 )
		

		#types = [] #Array
        	#types = %w( pdf odt doc xls 1 2 3 4 5 6 7 8 9 10 11 12 ) #Array
        	#@combo_tage = Combo.new
        	#@combo_tage.set_size_request( 60, 30 )
        	#@combo_tage.set_popdown_strings( tage )
        	#hbox.pack_start( @combo_tage )

			
		@frame2.add( @vbox3 )

		@frame3 = Frame.new
        	@frame3.set_label( "Action" )
		@vbox3 = VBox.new( false, 0 )

		@radioput=RadioButton.new(_("Send data: teacher --> students"))
        	@radioget=RadioButton.new(@radioput,_("Get data: teacher <-- students"))
        		
		@vbox3.add( @radioput )
		@vbox3.add( @radioget )
		

		 #ProgressBar
        	@pb = ProgressBar.new
       		 #Farbe des ProgressBars aendern
        	@pb.modify_bg( STATE_SELECTED, Gdk::Color.new( 50000, 0, 0 ) )
		@pb.fraction = 0
        	@vbox3.add( @pb )

		@frame3.add( @vbox3 )

		@vbox4=VBox.new(true,10)
		@vbox4.add( @frame2 )
		@vbox4.add( @frame3 )

		@hbox1=HBox.new(false,10)			
		@hbox1.add( @frame1 )
		@hbox1.add( @vbox4 )  
        	
		

      
		      	
		#@vbox1.pack_start( @frame )
		@vbox1.pack_start( @hbox1 )
		#@vbox1.pack_start( @frame3 )


        	btnok = Button.new( Stock::OK )
        	btnok.signal_connect( "clicked" ) { on_btn_clicked }
        	btncancel = Button.new( Stock::CANCEL )
        	btncancel.signal_connect( "clicked" ) { on_cancel_clicked }
		label=Label.new("                    ")
		label.show
		@hbox=HBox.new(false,10)
		@hbox.add(label)		
		@hbox.add( btncancel )
        	@hbox.add(btnok)
        	
        	@vbox1.pack_start( @hbox,false,false, 10 )
        	#vbox1.pack_start( btnok, false, false, 10 )

        	self.add( @vbox1 )
        	self.show_all
        end

	def on_select1_clicked
		@frame1.remove( @vbox2 )
		@vbox1.remove(@hbox)
		@hbox1.remove(@frame1 )
		@hbox1.remove( @vbox4 )       		
		self.remove(@vbox1)
       		#@vbox1 = VBox.new( false, 30 )
       		#@frame = Frame.new
        	#@frame.set_label( "Students" )
        	@vbox2 = VBox.new( true, 0 )
        	#CheckButtons
		k=0
		@chk=Array.new
		@hbox2=HBox.new(false,3)
        	while k < @listlength do
        	        hbox = HBox.new( false, 0 )
			
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		hbox.pack_start( icon, false, false, 10 )
			label = Label.new(@name[k][0..$gb_namelength.to_i].rjust($gb_namelength.to_i))
			label.set_width_chars($gb_namelength.to_i+2)
        		hbox.pack_start( label, false, false, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
			if @abutton=="A" then
				if @group[k].to_s.chomp=="group-A" then        		
				@chk[k].set_active('true')
				end			
			elsif @abutton=="B" then
				if @group[k].to_s.chomp=="group-B" then        		
				@chk[k].set_active('true')
				end
			elsif @abutton=="R" then
				#puts @abutton					
				#@chk[k].set_active('false')
			else	
				@chk[k].set_active('true')		
			end
			@chk[k].add(hbox)  
			l=k%3			
			if l!=0  then
				@hbox2.pack_start(@chk[k])
				@vbox2.pack_start(@hbox2)
			elsif				
				@hbox2=HBox.new(false,3)				
				@hbox2.pack_start(@chk[k])
				if k == @listlength-1 then
					@vbox2.pack_start(@hbox2)
				end
			end      		
		k += 1  
        	end
		while k< 5 do
				label=Label.new("")
				@vbox2.add(label)
				k +=1
		end 
		@btnremove = Button.new(Stock:: REMOVE)
        	@btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	@btnselect = Button.new(Stock::SELECT_ALL )
        	@btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	@hbox4 = HBox.new(false,10)
        	@hbox4.add(@btnselect)
        	 @hbox4.add(@btnremove)
		@btngroupa = Button.new("A" )
        	@btngroupa.signal_connect( "clicked" ) { on_groupa_clicked }
		@btngroupb = Button.new("B" )
        	@btngroupb.signal_connect( "clicked" ) { on_groupb_clicked }		
		@hbox4.add(@btngroupa)
		@hbox4.add(@btngroupb)
		@hbox4.show
		@vbox2.add(@hbox4)
		@frame1.add( @vbox2 )
        	@hbox1.add(@frame1)
		@hbox1.add( @vbox4)
		#@vbox1.pack_start( @frame )
		#@vbox1.pack_start( @hbox1 )
        	        	
        	        	
        	@vbox1.pack_start( @hbox,false,false, 10 )
        	#vbox1.pack_start( btnok, false, false, 10 )

        	self.add( @vbox1 )
        	self.show_all
        end
    
     def on_groupa_clicked
		@abutton="A"
		on_select1_clicked
	end   
	
	 def on_groupb_clicked
		@abutton="B"
		on_select1_clicked
	end

        def on_remove_clicked
		@abutton="R"
		on_select1_clicked
        end
   
    def on_select_clicked
		@abutton="S"
		on_select1_clicked
        end
   	def on_cancel_clicked
		self.destroy
	end
   
	def on_btn_clicked
       		
              	testing=File.exist?("#{$gb_dir}/#{$gb_errorlist}")
		if testing  then
			system("rm -r #{$gb_dir}/#{$gb_errorlist} >>/dev/null")     
		end
	               
		                                                          
            
		$gb_teacher_out=@entry[0].current_folder
		$gb_teacher_in=@entry[1].current_folder
		$gb_student_out=@entry[2].text
		$gb_student_in=@entry[3].text
		$gb_student_in_filter=@entry[4].text
		
		k=0
		i=0
        	while k < @listlength do
               		if @chk[k].active? then 
				if @name[k] then        			
					@active[i]=@ip[k]
					@active_name[i]=@name[k]
					i += 1
				end
        		end
        	   	k += 1
        	end

		 ssh_knownhosts_del
        	
		if @radioput.active? then
			
			i=0
			all_numbers=@active.count
			self.window.set_cursor(Gdk::Cursor.new(Gdk::Cursor::WATCH))
			Thread.start do			
			@active.each do
				|k|
				r=i+1
				r=r.to_f / all_numbers				
				@pb.fraction = r
				@pb.set_text( ( r * 100 ).to_i.to_s + "%"+"("+ @active_name[i]+")")
				puts @active_name[i].to_s
				copyput(k,@active_name[i])
				i+= 1
				if r<1 	then	
				
				self.show_all
				else
				show_error_datei				
				self.destroy
				end
				
			end
			end #thread
		else 
			i= 0
			all_numbers=@active.count
			@pb.orientation = Gtk::ProgressBar::RIGHT_TO_LEFT
			self.window.set_cursor(Gdk::Cursor.new(Gdk::Cursor::WATCH))
			Thread.start do	
			@active.each do
				|k|
				##puts "gets:"+k+":"+@active_name[i]
				r=i+1
				r=r.to_f / all_numbers				
				@pb.fraction = r

				@pb.set_text( ( r * 100 ).to_i.to_s + "%"+"("+ @active_name[i]+")")
				copyget(k,@active_name[i])
				i += 1
				if r<1 	then	
				self.show_all
				else
				show_error_datei
				self.destroy
				end
    			end
			end #thread
		end
		
			
        	#self.destroy
        end
   
   	

       def on_window_destroy
        #main_quit	     
	end
	
end #Ende CmdCheckbox


#init
#CopyCheckbox.new
#main
