#!/usr/bin/env ruby
    require 'gtk2'
 include Gtk

 class Animation < Window

     #Membervariablen
     @da
     @rot; @grau #Farben
     @vbox

    def initialize
        super

        self.set_title( "" )
        self.set_size_request( 80, 300 )
        self.signal_connect( "destroy" ) { main_quit }

        #Farben definieren
        @rot = Gdk::Color.new( 65535, 0, 0 )
        @grau = Gdk::Color.new( 30000, 30000, 30000 )

        @da = []
                                                           
        @vbox = VBox.new( true, 0 )
        for i in 0..9
            @da[ i ] = DrawingArea.new
            @da[ i ].show
            @vbox.pack_start( @da[ i ] )
        end

        self.add( @vbox )
        self.show_all

        starte_animation
    end

    #Animation
    def starte_animation
        k = 0
        Thread.start do
            loop do #Endlosschleife
                #puts "sadf"
                for i in 0..9
                    if i == k
                        @da[ k ].modify_bg( STATE_NORMAL, @rot )
                    else
                        @da[ i ].modify_bg( STATE_NORMAL, @grau )
                    end
                end
                #k muss sich immer zwischen 0 und 10 bewegen
                k = ( k + 1 ) % 11
                self.queue_draw
                sleep( 0.3 )
            end
        end
    end
end

init
Animation.new
main
