    require 'gtk2'
 include Gtk

 class Fenster < Window

     #Membervariablen
     @chk_freundlich
     @chk_hilfsbereit
     @chk_hoeflich

    def initialize
        super

        self.set_title( "" )
        self.set_border_width( 20 )
        self.set_size_request( 150, 200 )
        self.set_window_position( Position::MOUSE )
        self.signal_connect( "destroy" ) { main_quit }

        vbox1 = VBox.new( false, 10 )

        #Frame
        frame = Frame.new
        frame.set_label( "Eigenschaften" )

        vbox2 = VBox.new( true, 0 )

        #CheckButtons
        @chk_freundlich = CheckButton.new( "freundlich" )
        vbox2.pack_start( @chk_freundlich )

        @chk_hilfsbereit = CheckButton.new( "hilfsbereit" )
        vbox2.pack_start( @chk_hilfsbereit )

        @chk_hoeflich = CheckButton.new( "hflich" )
        vbox2.pack_start( @chk_hoeflich )

        frame.add( vbox2 )
        vbox1.pack_start( frame )

        btn = Button.new( Stock::OK )
        btn.signal_connect( "clicked" ) { on_btn_clicked }
        vbox1.pack_start( btn, false, false, 10 )

        self.add( vbox1 )
        self.show_all
    end

    def on_btn_clicked
        eigenschaften = 0
        msg = ""
        if @chk_freundlich.active?
            msg = msg + "Du bist freundlich!"
            eigenschaften += 1
        end
                                                                
        if @chk_hilfsbereit.active?
            msg = msg + "\nDu bist hilfsbereit!"
            eigenschaften += 1
        end
        if @chk_hoeflich.active?
            msg = msg + "\nDu bist hflich!"
            eigenschaften += 1
        end

        if eigenschaften == 0
            msg = "Du solltest dich ein wenig anstrengen!"
        end

        dialog = MessageDialog.new( self, 1, 0, 1, msg )
        dialog.run
        dialog.destroy
    end
end
