#!/usr/bin/env ruby

 require 'gtk2'
 include Gtk

 class Fenster < Window

     #Membervariablen
     @combo_tage
    @combo_monate
    @combo_jahre

    def initialize
        super

        self.set_title( "" )
        self.set_border_width( 20 )
        self.signal_connect( "destroy" ) { main_quit }

        hbox = HBox.new( false, 10 )

        #Tage
        tage = [] #Array
        for i in 0..30
            tage[ i ] = ( i + 1 ).to_s
        end
        @combo_tage = Combo.new
        @combo_tage.set_size_request( 60, 30 )
        @combo_tage.set_popdown_strings( tage )
        hbox.pack_start( @combo_tage )

        #Monate
        monate = %w( 1 2 3 4 5 6 7 8 9 10 11 12 ) #Array
        @combo_monate = Combo.new
        @combo_monate.set_size_request( 60, 30 )
        @combo_monate.set_popdown_strings( monate )
        hbox.pack_start( @combo_monate )

        #Jahre
        jahre = [] #Array
        for i in 0..100
            jahre[ i ] = ( i + 1905 ).to_s
        end
        @combo_jahre = Combo.new
        @combo_jahre.set_size_request( 100, 30 )
        @combo_jahre.set_popdown_strings( jahre )
        hbox.pack_start( @combo_jahre )

        #VBox
        vbox = VBox.new( false, 10 )
                                                             
        vbox.pack_start( Label.new( "Geburtstag" ) )
        vbox.pack_start( hbox, false, false, 10 )

        #Button
        btn_start = Button.new( Stock::OK )
        btn_start.signal_connect( "clicked" ) { on_btn_start_clicked }
        vbox.pack_start( btn_start, false, false, 10 )

        self.add( vbox )
        self.show_all
    end

    def on_btn_start_clicked
        tag = @combo_tage.entry.text
        monat = @combo_monate.entry.text
        jahr = @combo_jahre.entry.text
        #puts "Du bist am " + tag + "." + monat + "." + jahr + " geboren."
    end

end

init
Fenster.new
main
