#!/usr/bin/env ruby

 require 'gtk2'
 include Gtk

 class Fenster < Window

     #Membervariablen
     @f #Feld
    @tab

    def initialize
        super

        self.set_title( "Matrix" )
        self.signal_connect( "destroy" ) { main_quit }

        @tab = Table.new( 3, 3, true )
        @f = []
        k = 0
        for i in 0...3
            for j in 0...3
                @f[ k ] = Entry.new
                @f[ k ].set_size_request( 50, 25 )
                @f[ k ].signal_connect( "button_press_event" ) do
                    | widget, event |
                    on_feld_button_press_event( event )
                end
                @tab.attach( @f[ k ], j, j + 1, i, i + 1 )
                k += 1
                                                                      
         end
     end

     self.add( @tab )
     self.show_all
 end

 def on_feld_button_press_event( event )
     if event.button == 3 #wenn rechte Maustaste gedrckt wurde
         menu = Menu.new

         menu_det = MenuItem.new( "det" )
         menu_det.set_name( "det" )
         menu_det.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget )
         end
         menu.append( menu_det )

         menu_del = MenuItem.new( "lschen" )
         menu_del.set_name( "del" )
         menu_del.signal_connect( "activate" ) do
             | widget |
             on_menu_activate( widget )
         end
         menu.append( menu_del )

         menu.show_all
         menu.popup( nil, nil, event.button, event.time )
     end
 end

 def on_menu_activate( w )
     if w.name == "det"
         det
     elsif w.name == "del"
         del
     end
 end

 #Methode zur Berechnung der Determinante
 def det
     d = @f[ 0 ].text.to_i * @f[ 4 ].text.to_i *  @f[ 8 ].text.to_i + \
     @f[ 1 ].text.to_i * @f[ 5 ].text.to_i * @f[  6 ].text.to_i + \
     @f[ 2 ].text.to_i * @f[ 3 ].text.to_i * @f[  7 ].text.to_i - \
     @f[ 6 ].text.to_i * @f[ 4 ].text.to_i * @f[  2 ].text.to_i - \
     @f[ 7 ].text.to_i * @f[ 5 ].text.to_i * @f[  0 ].text.to_i - \
     @f[ 8 ].text.to_i * @f[ 3 ].text.to_i * @f[  1 ].text.to_i

     msg = "Determinante: " + d.to_s
     dialog = MessageDialog.new( self, 0, 0, 1, msg )
     dialog.run
     dialog.destroy
 end

 #Methode lscht Elemente der Matrix und setzt Cursor in erstes Feld
 def del
     for i in 0...9
                                                                            
            @f[ i ].set_text( "" )
        end
        @f[ 0 ].set_focus( true )
    end

end

init
Fenster.new
main
