    #!/usr/bin/env ruby

 require 'gtk2'
 include Gtk

 class Fenster < Window

     def initialize
          super

         self.set_title( "TextView" )
         self.set_border_width( 20 )
         self.set_size_request( 600, 400 )
         self.maximize
         self.set_window_position( Position::MOUSE )
         self.signal_connect( "destroy" ) { main_quit }

         textbuffer = TextBuffer.new
         textbuffer.set_text( "beliebiger Text..." )

         textview = TextView.new
         textview.set_buffer( textbuffer )
         textview.set_editable( false )
         textview.set_cursor_visible( false )

         scw = ScrolledWindow.new
         scw.add_with_viewport( textview )

         self.add( scw )
         self.show_all
    end

end
