#!/usr/bin/env ruby
  $LOAD_PATH.unshift File.dirname($PROGRAM_NAME)
 require 'gtk2'
require 'get_client_list'
require 'get_cmd_list'
require 'web_control_cmd'
require 'port_cmd'
require 'group_control_cmd'
require 'execute_cmd'
require 'get_global_list'
require '~/.laulc/conf/global'
 include Gtk
require 'gettext'
include GetText
 bindtextdomain("cmd_checkbox", :path => '/usr/local/bin/km/liveusbcontrol/locale') 


 class CmdCheckbox < Window
	@eventbox
	@tab
	@btnok
	@listlength
	@listlength_cmd
	@chk
	@chk_cmd
	@name
	@group
	@name_cmd
	@cmd
	@ip
	@vbox1
	@vbox2
	@vbox3
	@hbox1
	@hbox2
	@radioopen
	@radioclose
	@frame1
	@frame2
	@hbox
	@active
	@teacher_out
	@student_in
	
	
	def initialize
         	@dir_home=`echo ~`
		@dir_home=@dir_home.chomp

		@rot = Gdk::Color.new( 65535, 0, 0 )

		@chk=Array.new
		@chk_cmd = Array.new
		@active = Array.new
         	super
         	self.signal_connect( "destroy" ) do
            		on_window_destroy
        	end
         	
        	self.set_modal(true)
        	self.set_border_width( 3 )
	        self.set_window_position( Position::CENTER )
		self.set_resizable( false )
		clientlist=GetClientList.new("#{$gb_dir}/#{$gb_clientlist}")
		@name=clientlist.get_clientname
		@ip=clientlist.get_ipaddress
		@listlength=@name.length
	        @group=clientlist.get_group

		#getcmd list
		cmdlist=GetCmdList.new("#{$gb_working_dir}/#{$gb_cmdlist}")
		@name_cmd=cmdlist.get_cmdname
		@cmd=cmdlist.get_cmd
		@listlength_cmd=@name_cmd.length

		#get_global_list
		@filename="#{$gb_dir}/conf/global.rb"
		file=GetGlobalList.new(@filename)
		@global=file.get_globalcontent

        	@vbox1 = VBox.new( false, 30 )
        	#banner
		icon = Image.new("#{$gb_working_dir}/icons/la-banner-exam.png")
		@vbox1.add(icon)
		#Frame
        	@frame1 = Frame.new
        	@frame1.set_label( _("Students") )
		@vbox2 = VBox.new( true, 0 )
        	
		#CheckButtons
		k=0
		@hbox2=HBox.new(false,3)
        	while k < @listlength do
        	        hbox = HBox.new( true, 0 )
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		hbox.pack_start( icon, false, false, 10 )
			label = Label.new( @name[k].to_s)
        		hbox.pack_start( label, true, true, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
			@chk[k].set_active('true')
			@chk[k].add(hbox)  
			l=k%3	 
			if l!=0  then
				@hbox2.pack_start(@chk[k])
				@vbox2.pack_start(@hbox2)
			elsif				
				@hbox2=HBox.new(false,3)				
				@hbox2.pack_start(@chk[k])
				if k == @listlength-1 then
					@vbox2.pack_start(@hbox2)
				end

			end        		
		k += 1  
        	end
		while k< 6 do
				label=Label.new("")
				@vbox2.add(label)
				k +=1
		end 
        
		btnremove = Button.new(Stock:: REMOVE)
        	btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	btnselect = Button.new(Stock::SELECT_ALL )
        	btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
        	@hbox = HBox.new
        	@hbox.add(btnselect)
        	@hbox.add(btnremove)
		@btngroupa = Button.new("A" )
        	@btngroupa.signal_connect( "clicked" ) { on_groupa_clicked }
		@btngroupb = Button.new("B" )
        	@btngroupb.signal_connect( "clicked" ) { on_groupb_clicked }		
		@hbox.add(@btngroupa)
		@hbox.add(@btngroupb)

		@vbox2.pack_start(@hbox)
		@frame1.add( @vbox2 )	


			
		
		#checkbox for cmds 
		#Frame
        	@frame2 = Frame.new
        	@frame2.set_label( "Commands" )
		@vbox3 = VBox.new( true, 0 )
        	
		k=0
        	while k < @listlength_cmd do
        	       	@chk_cmd[k]=CheckButton.new(@name_cmd[k].to_s)
			if     @name_cmd[k].to_s.chomp!='Port-Lock' then    		
			@chk_cmd[k].set_active('true')
			end
        		@vbox3.pack_start(@chk_cmd[k])
        		k += 1 
        	end

		
		
		@frame2.add( @vbox3 )

		@hbox1=HBox.new(false,10)			
		@hbox1.add( @frame1 )
		@hbox1.add( @frame2 )  
        	
		
		      	
		#@vbox1.pack_start( @frame )
		@vbox1.pack_start( @hbox1 )


		#teacherdirs
		@teacher_out= FileChooserButton.new("Application", FileChooser::ACTION_SELECT_FOLDER)
		test=@global['$gb_teacher_out'].slice(/~/)
		if test == "~" then  
						
			@global['$gb_teacher_out']=@global['$gb_teacher_out'].sub("~","#{@dir_home}")
		end
		#puts @global['$gb_teacher_out'].chomp	
		@teacher_out.current_folder = "#{@global['$gb_teacher_out'].chomp}"
        	@teacher_out.show
        	@hbox3 = HBox.new(false,5)	
        	label = Label.new( _("Teacher-Out-Directory: "))
        	label.show
        	@hbox3.add(label)
        	@hbox3.add(@teacher_out)
        	@hbox3.show
		#@vbox3.add( hbox3 )
		

		@student_in = Entry.new
		@student_in.text = "#{@global['$gb_student_in'].chomp}"
        	@student_in.show
        	#hbox3 = HBox.new	
        	label = Label.new( _("Student-In-Directory: "))
        	label.show
        	@hbox3.add(label)
        	@hbox3.add(@student_in)
        	@hbox3.show
		#@vbox3.add( hbox3 )



        	@btnok = Button.new( Stock::OK )
        	@btnok.signal_connect( "clicked" ) { on_btn_clicked }
        	@btncancel = Button.new( Stock::CANCEL )
        	@btncancel.signal_connect( "clicked" ) { on_cancel_clicked }
        	label=Label.new("                    ")
		label.show
		
		@hbox2=HBox.new(false,10)
		@hbox2.add( label)
		@hbox2.add( @btncancel )
		@hbox2.add( @btnok )
        	        	
        	#@vbox1.pack_start( @hbox,false,false, 10 )
		@vbox1.pack_start( @hbox3, true, true, 3 )   	
		@vbox1.pack_start( @hbox2, true, true, 3 )
		
        	self.add( @vbox1 )
        	self.show_all
        end

	def on_cancel_clicked
		self.destroy
	end
		
	def on_select1_clicked
		@frame1.remove( @vbox2 )
		@vbox1.remove(@hbox1)
		@vbox1.remove(@hbox2)
		@vbox1.remove(@hbox3)
		@hbox1.remove(@frame1 )
		@hbox1.remove( @frame2 )       		
		self.remove(@vbox1)
       		#@vbox1 = VBox.new( false, 30 )
       		@frame1 = Frame.new
        	@frame1.set_label( "Students" )
        	@vbox2 = VBox.new( true, 0 )
        	#CheckButtons
		k=0
		@chk=Array.new
        	while k < @listlength do
        	        hbox = HBox.new( true, 0 )
			icon = Image.new("#{$gb_working_dir}/icons/network-server.png")
        		hbox.pack_start( icon, true, true, 10 )
			label = Label.new( @name[k].to_s)
        		hbox.pack_start( label, true, true, 10 )
					
        	       	@chk[k]=CheckButton.new #(@name[k].to_s)
        		if @abutton=="A" then
				if @group[k].to_s.chomp=="group-A" then        		
				@chk[k].set_active('true')
				end			
			elsif @abutton=="B" then
				if @group[k].to_s.chomp=="group-B" then        		
				@chk[k].set_active('true')
				end
			elsif @abutton=="R" then
				#puts @abutton					
				#@chk[k].set_active('false')
			else	
				@chk[k].set_active('true')		
			end
			@chk[k].add(hbox) 
			l=k%3	 
			if l!=0  then
				@hbox2.pack_start(@chk[k])
				@vbox2.pack_start(@hbox2)
			elsif				
				@hbox2=HBox.new(false,3)				
				@hbox2.pack_start(@chk[k])
				if k == @listlength-1 then
					@vbox2.pack_start(@hbox2)
				end

			end        		
		k += 1   
        	end
		while k< 6 do
				label=Label.new("")
				@vbox2.add(label)
				k +=1
		end 

		btnremove = Button.new(Stock:: REMOVE)
        	btnremove.signal_connect( "clicked" ) { on_remove_clicked }
        	btnselect = Button.new(Stock::SELECT_ALL )
        	btnselect.signal_connect( "clicked" ) { on_select_clicked }
        	
		
        	@hbox = HBox.new
        	@hbox.add(btnselect)
        	@hbox.add(btnremove)
		@btngroupa = Button.new("A" )
        	@btngroupa.signal_connect( "clicked" ) { on_groupa_clicked }
		@btngroupb = Button.new("B" )
        	@btngroupb.signal_connect( "clicked" ) { on_groupb_clicked }		
		@hbox.add(@btngroupa)
		@hbox.add(@btngroupb)
		@hbox.show
		@vbox2.pack_start(@hbox)
		@vbox2.show
		
        	@frame1.add( @vbox2 )
        	@hbox1.add(@frame1)
		@hbox1.add( @frame2)
		@vbox1.pack_start( @hbox1 )
        	  



		@btnok = Button.new( Stock::OK )
        	@btnok.signal_connect( "clicked" ) { on_btn_clicked }
        	@btncancel = Button.new( Stock::CANCEL )
        	@btncancel.signal_connect( "clicked" ) { on_cancel_clicked }
        	label=Label.new("                    ")
		label.show
		
		@hbox2=HBox.new(false,10)
		@hbox2.add( label)
		@hbox2.add( @btncancel )
		@hbox2.add( @btnok )     	
        	@vbox1.pack_start( @hbox3, true, true, 5 )   	
        	@vbox1.pack_start( @hbox2, true, true, 5 )

        	self.add( @vbox1 )
        	self.show_all
        end
   
   	def on_groupa_clicked
		@abutton="A"
		on_select1_clicked
	end   
	
	 def on_groupb_clicked
		@abutton="B"
		on_select1_clicked
	end

        def on_remove_clicked
		@abutton="R"
		on_select1_clicked
        end
    
	def on_select_clicked
		@abutton="S"
		on_select1_clicked
        end
   
   
	def on_btn_clicked
       		
		$gb_teacher_out=@teacher_out.current_folder
		$gb_student_in=@student_in.text
		#Cmdfile erzeugen
       		file=File.new("#{$gb_dir}/#{$gb_cmdactual}",'w')
       		 k=0
		i=0
        	while k < @listlength do
               		if @chk[k].active? then 
        			file.#puts @name[k].to_s+","+@ip[k]
				@active[i]=@ip[k]
				i += 1
        		end
        	   	k += 1
        	end
        	file.close
		k=0		
		while k < @listlength_cmd do		
			if @chk_cmd[k].active? then
				@active.each do
					|address|
					##puts @cmd[k].to_s+","+address
					execute_cmd(@cmd[k],address)
    				end
			end
		k += 1
		end

        	self.destroy
        end
   
   	

       def on_window_destroy
        #main_quit	     
	end
	
end #Ende CmdCheckbox


#init
#CmdCheckbox.new
#main
